#include "camera.h"

//----------------------------------//
//	RXgN^					//
//									//
//			Ȃ						//
//									//
//	߂l	Ȃ						//
//----------------------------------//
Camera::Camera():
m_Length(0.0f),
m_Yaw(0.0),m_Pitch(0.0)
{
}

//----------------------------------//
//	fXgN^						//
//									//
//			Ȃ						//
//									//
//	߂l	Ȃ						//
//----------------------------------//
Camera::~Camera()
{
}



//----------------------------------//
//	_ʒuƎΏۈʒuZbg		//
//									//
//			Eye	ʒu				//
//			At	Ώۂ̈ʒu		//
//									//
//	߂l	Ȃ						//
//----------------------------------//
void Camera::SetEyeAtPos(const D3DXVECTOR3 &Eye,const D3DXVECTOR3 &At)
{
	if(Eye == At)
		return;

	m_Eye = Eye;
	m_At = At;

	D3DXVECTOR3 dist = m_At - m_Eye;
	m_Length = D3DXVec3Length(&dist);
	D3DXVECTOR3 distcos(dist.x,0.0f,dist.z);

	m_Pitch = -atan2(dist.y,D3DXVec3Length(&distcos));	// sb`߂
	m_Yaw	= -atan2(dist.z,dist.x);		// [߂

	if(m_Pitch < D3DX_PI * 0.5 && m_Pitch > -D3DX_PI * 0.5)
		m_Up = D3DXVECTOR3(0,1,0);

	if(m_Pitch < D3DX_PI * 1.5 && m_Pitch > D3DX_PI * 0.5)
		m_Up = D3DXVECTOR3(0,-1,0);

	if( m_Pitch == D3DX_PI * 0.5 || m_Pitch == D3DX_PI * 1.5 ||
		m_Pitch == D3DX_PI * 0.5 || m_Pitch == D3DX_PI * 1.5	 )
	{
		D3DXVECTOR3 temp((float)cos(m_Yaw),0,0);
		D3DXVec3Normalize(&m_Up,&temp);
	}
}

//----------------------------------//
//	px̃Zbg						//
//									//
//			yaw		[]px		//
//			pitch	sb`]px	//
//									//
//	߂l	Ȃ						//
//----------------------------------//
void Camera::SetRad(const double yaw,const double pitch)
{
	m_Yaw = yaw;
	m_Pitch = pitch;
}

//----------------------------------//
//	̃Zbg						//
//									//
//			length 				//
//									//
//	߂l	Ȃ						//
//----------------------------------//
void Camera::SetLength(const double length)
{
	if(length < 0)
		return;

	m_Length = length;
}

//----------------------------------//
//	ΏۈʒuXV					//
//									//
//			MoveCam	XV			//
//									//
//	߂l	Ȃ						//
//----------------------------------//
void Camera::UpdateAt(const D3DXVECTOR3 &MoveAt)
{
	if(m_Eye == (m_At + MoveAt))
		return;

	m_At += MoveAt;
}

//----------------------------------//
//	px̍XV						//
//									//
//			yaw		[]px		//
//			pitch	sb`]px	//
//									//
//	߂l	Ȃ						//
//----------------------------------//
void Camera::UpdateRad(const float yaw,const float pitch)
{
	m_Yaw += yaw;
	m_Pitch += pitch;
}

//----------------------------------//
//	̍XV						//
//									//
//			length 				//
//									//
//	߂l	Ȃ						//
//----------------------------------//
void Camera::UpdateLength(float length)
{
	if(m_Length - length < 0.0f){
		D3DXVECTOR3 temp;
		D3DXVec3Normalize(&temp,&(m_At - m_Eye));
		m_At += temp * length;
		return;
	}

	m_Length -= length;
}

//------------------------------------------//
//  ۂߏ֐
//  _w肳ꂽxŊۂ߂lԂ
//
//		val	       ۂ߂l
//        	precision  x
// 
//	߂l	w萸xŊۂ߂l
//------------------------------------------//
double Round( double val, int precision )
{
	/* ***** ϐ` ***** */
	double		ret;
	char		buf[256] = {};
	char		*p;

	/* ***** ۂ߂sɕϊ ***** */
	sprintf_s( buf,256 * sizeof(char),"%.*f", precision, val );
	/* ***** 񂩂琔lɍĕϊ ***** */
	ret = strtod( buf, &p );

	return ret;
}

//----------------------------------//
//	J̍XV						//
//									//
//			Ȃ						//
//									//
//	߂l	Ȃ						//
//----------------------------------//
void Camera::Update()
{
	m_Pitch  = Round(m_Pitch,6);	// x_6
	m_Yaw	 = Round(m_Yaw,6);	// x_6

	if(m_Pitch > D3DX_PI * 1.5)
		m_Pitch -= D3DX_PI * 2.0;

	if(m_Pitch < -D3DX_PI * 0.5)
		m_Pitch += D3DX_PI * 2.0;

	if(m_Pitch < D3DX_PI * 0.5 && m_Pitch > -D3DX_PI * 0.5)
		m_Up = D3DXVECTOR3(0,1,0);

	if(m_Pitch < D3DX_PI * 1.5 && m_Pitch > D3DX_PI * 0.5)
		m_Up = D3DXVECTOR3(0,-1,0);

	if( m_Pitch == D3DX_PI * 0.5 || m_Pitch == D3DX_PI * 1.5 ||
		m_Pitch == D3DX_PI * 0.5 || m_Pitch == D3DX_PI * 1.5	 )
	{
		D3DXVECTOR3 temp((float)cos(m_Yaw),0,0);
		D3DXVec3Normalize(&m_Up,&temp);
	}

	m_Eye = D3DXVECTOR3(static_cast<float>(m_Length * cos(m_Pitch) * cos(m_Yaw)),
		static_cast<float>(m_Length * sin(m_Pitch)),
		static_cast<float>(m_Length * cos(m_Pitch) * sin(m_Yaw)));

	//^[Qbg̈ʒu܂ŕsړ
	D3DXMATRIX mtx;
	D3DXMatrixIdentity(&mtx);
	D3DXMatrixTranslation(&mtx,m_At.x,m_At.y,m_At.z);
	D3DXVec3TransformCoord(&m_Eye,&m_Eye,&mtx);

	// r[ϊs쐬
	D3DXMatrixLookAtLH(&m_ViewMtx,&m_Eye,&m_At,&m_Up);


}

//----------------------------------//
//	ˉeϊs̍쐬
//
//	:	Aspect   AXyNg	
//			Far		 t@[Nbv
//			Near	 jANbv
//			Fovy	 piSTxʏj
//
//	߂lFȂ
//----------------------------------//
void Camera::SetProjMatrix(float Aspect,float Far,float Near,float Fovy)
{
	// ˉeϊs̍쐬
	D3DXMatrixPerspectiveFovLH(&m_ProjMtx,Fovy,Aspect,Near,Far);
}

//----------------------------------//
//	ˉeϊs̍쐬
//
//	:	W		r[
//			H		r[
//			Far		t@[Nbv
//			Near	jANbv
//
//	߂lFȂ
//----------------------------------//
void Camera::SetOrthoMatrix(float W,float H,float Far,float Near )
{
	// ˉeϊs̍쐬
	D3DXMatrixOrthoLH(&m_ProjMtx,W,H,Far,Near);
}

//----------------------------------//
//	r[ϊs擾				//
//									//
//			Ȃ						//
//									//
//	߂l	r[ϊs			//
//----------------------------------//
D3DXMATRIX Camera::GetViewMatrix()
{
	return m_ViewMtx;
}

//----------------------------------//
//	ˉeϊs擾					//
//									//
//			Ȃ						//
//									//
//	߂l	ˉeϊs				//
//----------------------------------//
D3DXMATRIX Camera::GetProjMatrix()
{
	return m_ProjMtx;
}

//----------------------------------//
//	_擾							//
//									//
//			Ȃ						//
//									//
//	߂l	_						//
//----------------------------------//
D3DXVECTOR3 Camera::GetEye()
{
	return m_Eye;
}

//----------------------------------//
//	_擾						//
//									//
//			Ȃ						//
//									//
//	߂l	_					//
//----------------------------------//
D3DXVECTOR3 Camera::GetAt()
{
	return m_At;
}

//----------------------------------//
//	AbvxNg擾				//
//									//
//			Ȃ						//
//									//
//	߂l	AbvxNg			//
//----------------------------------//
D3DXVECTOR3 Camera::GetUp()
{
	return m_Up;
}

//----------------------------------//
//	[擾							//
//									//
//			Ȃ						//
//									//
//	߂l	[]					//
//----------------------------------//
float Camera::GetYaw()
{
	return static_cast<float>(m_Yaw);
}

//----------------------------------//
//	sb`擾						//
//									//
//			Ȃ						//
//									//
//	߂l	sb`]				//
//----------------------------------//
float Camera::GetPitch()
{
	return static_cast<float>(m_Pitch);
}

//----------------------------------//
//	JʕiKς݁j擾	//
//									//
//			Ȃ						//
//									//
//	߂l	JʕxNg	//
//----------------------------------//
D3DXVECTOR3 Camera::GetDirection()
{
	D3DXVECTOR3 Dir;
	Dir = m_At - m_Eye;
	D3DXVec3Normalize(&Dir,&Dir);
	return Dir;
}

//-----------------------------------------//
//	}EX̃[hWł̃C擾
//	
//			pD3DDevice	3DfoCX
//			pOutNear	C̎n_
//			pOutFar		C̏I_
//
//	߂l	Ȃ
//-----------------------------------------//
void Camera::GetMousePicker(IDirect3DDevice9* pD3DDevice,D3DXVECTOR3* pOutNear,D3DXVECTOR3* pOutFar)
{
	POINT MousePt;
	GetCursorPos(&MousePt);

	D3DVIEWPORT9 vp;
	pD3DDevice->GetViewport( &vp );
	
	MousePt.x = max(min(MousePt.x, (long)vp.Width), 0);
	MousePt.y = max(min(MousePt.y, (long)vp.Height), 0);
	*pOutNear = D3DXVECTOR3((float)MousePt.x,(float)MousePt.y,0.0f);	// z = 0.0f jANbvʒu
	*pOutFar  = D3DXVECTOR3((float)MousePt.x,(float)MousePt.y,1.0f);	// z = 1.0f t@[Nbvʒu
	D3DXMATRIX& ScreenToWorldMtx = ScreenToWorld(pD3DDevice);

	D3DXVec3TransformCoord(pOutNear,pOutNear,&ScreenToWorldMtx);
	D3DXVec3TransformCoord(pOutFar,pOutFar,&ScreenToWorldMtx);
}

//-----------------------------------------------------//
//	XN[W烏[hWւ̕ϊs쐬
//
//			pD3DDevice	3DfoCX
//			
//	߂l	XN[W烏[hWւ̕ϊs
//-----------------------------------------------------//
D3DXMATRIX Camera::ScreenToWorld(IDirect3DDevice9* pD3DDevice)
{
    // r[|[gs쐬
    D3DXMATRIX ViewPortMtx;
    D3DXMatrixIdentity( &ViewPortMtx);

    D3DVIEWPORT9 vp;
    pD3DDevice->GetViewport( &vp );

    ViewPortMtx._11 = (float)vp.Width / 2;
    ViewPortMtx._22 = -1.0f * (float)(vp.Height / 2);
    ViewPortMtx._33 = (float)vp.MaxZ - vp.MinZ;
    ViewPortMtx._41 = (float)( vp.X + vp.Width / 2 );
    ViewPortMtx._42 = (float)( vp.Y + vp.Height / 2 );
    ViewPortMtx._43 = vp.MinZ;

    D3DXMATRIX ScreenToWorldMtx, InvProjMtx, InvViewMtx;
	D3DXMatrixInverse( &ScreenToWorldMtx, 0, &ViewPortMtx );
	D3DXMatrixInverse( &InvProjMtx, 0, &m_ProjMtx );
	D3DXMatrixInverse( &InvViewMtx, 0, &m_ViewMtx );

	ScreenToWorldMtx *= InvProjMtx * InvViewMtx;

	return ScreenToWorldMtx;

}