//----------------------------------//
//	CameraNXA_			//
//									//
//	쐬		Daiki Terai			//
//	쐬		2010/01/04			//
//	C		2011/07/28			//
//----------------------------------//

#ifndef _CAMERA_H_
#define _CAMERA_H_

#include "direct3d9.h"

// TvAp[^王_ϊs쐬
class Camera
{
private:
	D3DXVECTOR3 m_Eye,m_At,m_Up;// ݂̃JʒuAĂ̂̈ʒuAJ
	D3DXMATRIX	m_ViewMtx;		// 쐬ꂽr[ϊs 
	D3DXMATRIX	m_ProjMtx;		// ˉeϊs
	double		m_Yaw,m_Pitch;	// [iY]pxjAsb`iX]pxj
	double		m_Length;		// JƎΏۃIuWFNg̋

public:
	//----------------------------------//
	//	RXgN^					//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	Camera();

	//----------------------------------//
	//	fXgN^						//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	virtual ~Camera();

	//----------------------------------//
	//	_ʒuƎΏۈʒuZbg		//
	//									//
	//			Eye	ʒu				//
	//			At	Ώۂ̈ʒu		//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	void SetEyeAtPos(const D3DXVECTOR3 &Eye,const D3DXVECTOR3 &At);
	
	//----------------------------------//
	//	px̃Zbg						//
	//									//
	//			yaw		[]px		//
	//			pitch	sb`]px	//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	void SetRad(const double yaw,const double pitch);

	//----------------------------------//
	//	̃Zbg						//
	//									//
	//			length 				//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	void SetLength(const double length);

	//----------------------------------//
	//	ΏۈʒuXV					//
	//									//
	//			MoveAt	XV			//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	void UpdateAt(const D3DXVECTOR3 &MoveAt);

	//----------------------------------//
	//	px̍XV						//
	//									//
	//			yaw		[]px		//
	//			pitch	sb`]px	//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	void UpdateRad(const float yaw,const float pitch);

	//----------------------------------//
	//	̍XV						//
	//									//
	//			length 				//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	void UpdateLength(float length);

	//----------------------------------//
	//	J̍XV						//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	Ȃ						//
	//----------------------------------//
	void Update();

	//----------------------------------//
	//	ˉeϊs̍쐬
	//
	//	:	Aspect   AXyNg	
	//			Far		 t@[Nbv
	//			Near	 jANbv
	//			Fovy	 piSTxʏj
	//
	//	߂lFȂ
	//----------------------------------//
	void SetProjMatrix(float Aspect,float Far = 1000.0f,float Near = 0.1f,float Fovy = D3DXToRadian(45));

	//----------------------------------//
	//	ˉeϊs̍쐬
	//
	//	:	W		r[
	//			H		r[
	//			Far		t@[Nbv
	//			Near	jANbv
	//
	//	߂lFȂ
	//----------------------------------//
	void SetOrthoMatrix(float W,float H,float Far = 1000.0f,float Near = 0.1f);


	//----------------------------------//
	//	r[ϊs擾				//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	r[ϊs			//
	//----------------------------------//
	D3DXMATRIX GetViewMatrix();

	//----------------------------------//
	//	ˉeϊs擾					//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	ˉeϊs				//
	//----------------------------------//
	D3DXMATRIX GetProjMatrix();

	//----------------------------------//
	//	_擾							//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	_						//
	//----------------------------------//
	D3DXVECTOR3 GetEye();

	//----------------------------------//
	//	_擾						//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	_					//
	//----------------------------------//
	D3DXVECTOR3 GetAt();

	//----------------------------------//
	//	AbvxNg擾				//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	AbvxNg			//
	//----------------------------------//
	D3DXVECTOR3 GetUp();

	//----------------------------------//
	//	[擾							//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	[]					//
	//----------------------------------//
	float GetYaw();

	//----------------------------------//
	//	sb`擾						//
	//									//
	//		Ȃ							//
	//									//
	//	߂l	sb`]				//
	//----------------------------------//
	float GetPitch();

	//----------------------------------//
	//	JʕiKς݁j擾	//
	//									//
	//			Ȃ						//
	//									//
	//	߂l	JʕxNg	//
	//----------------------------------//
	D3DXVECTOR3 GetDirection();

	//-----------------------------------------//
	//	}EX̃[hWł̃C擾
	//	
	//			pD3DDevice	3DfoCX
	//			pOutNear	C̎n_
	//			pOutFar		C̏I_
	//
	//	߂l	Ȃ
	//-----------------------------------------//
	void GetMousePicker(IDirect3DDevice9* pD3DDevice,D3DXVECTOR3* pOutNear,D3DXVECTOR3* pOutFar);
	//-----------------------------------------------------//
	//	XN[W烏[hWւ̕ϊs쐬
	//
	//			pD3DDevice	3DfoCX
	//			
	//	߂l	XN[W烏[hWւ̕ϊs
	//-----------------------------------------------------//
	D3DXMATRIX ScreenToWorld(IDirect3DDevice9* pD3DDevice);

};


#endif