#include "debugcamera.h"

// JXV
void DebugCamera::DebugUpdate(DirectInput& Input,float MoveCamZScale,float MoveCamXYScale,float RotScale)
{
	float yaw = 0.0f,pitch = 0.0f;
	D3DXVECTOR3	MoveAt(0,0,0);
	float length = 0.0f;
	long z = Input.GetMouseMove(MOUSE_lZ);
	length = z * MoveCamZScale;

	// ENbN
	if(Input.GetMouseInputState(RIGHT_CLICK) == INPUTSTATE_PUSH && z == 0)
	{
		long x = Input.GetMouseMove(MOUSE_lX);
		long y = Input.GetMouseMove(MOUSE_lY);

		yaw = D3DX_PI * (x / 180.0f) * RotScale;
		pitch = D3DX_PI * (y / 180.0f) * RotScale;
	}
	// ^񒆃{^
	if(Input.GetMouseInputState(MIDDLE_CLICK)  == INPUTSTATE_PUSH && z == 0)
	{
		long x = Input.GetMouseMove(MOUSE_lX);
		long y = Input.GetMouseMove(MOUSE_lY);

		// Aɑ΂ďɈړxNg쐬
		D3DXVECTOR3 Up = this->GetUp();
		D3DXVECTOR3 At = this->GetAt();
		D3DXVECTOR3 Eye = this->GetEye();

		D3DXVECTOR3 tmp1,tmp2;
		D3DXVec3Cross(&tmp1,&(Eye-At),&Up);
		D3DXVec3Normalize(&tmp2,&tmp1);
		MoveAt = tmp2 * (float)x * MoveCamXYScale;

		D3DXVec3Cross(&tmp2,&(Eye-At),&tmp1);
		D3DXVec3Normalize(&tmp1,&tmp2);
		MoveAt += tmp1 * (float)y * MoveCamXYScale;
	}

	this->UpdateAt(-MoveAt);	// ΏۍXV	
	this->UpdateLength(length);	// JXV
	this->UpdateRad(yaw,pitch);	// J]XV
	this->Update();				// r[ϊs̍쐬

}


//------------------------------------------------
//	ړxNg擾iJʕj
//
//	F	Input		DirectInput
//			FrontKey	OړL[
//			BackKey		ړL[
//			LeftKey		ړL[		
//			RightKey	EړL[
//
//	߂lFړxNg
//------------------------------------------------
D3DXVECTOR3 DebugCamera::GetMove(
		DirectInput& Input,
		UINT FrontKey,
		UINT BackKey,
		UINT LeftKey,
		UINT RightKey)
{
	D3DXVECTOR3 Dir = this->GetDirection();
	D3DXVec3Normalize(&Dir,&D3DXVECTOR3(Dir.x,0.0f,Dir.z));
	D3DXVECTOR3 DirFrontBack(0,0,0);
	D3DXVECTOR3 DirLeftRight(0,0,0);
	D3DXMATRIX rotYPlus,rotYMinus;
	D3DXMatrixRotationY(&rotYPlus,D3DX_PI/2.0f);
	D3DXMatrixRotationY(&rotYMinus,-D3DX_PI/2.0f);

	// O
	if(Input.GetKeyInputState(FrontKey) == INPUTSTATE_PUSH){
		DirFrontBack = Dir;
	}
	// 
	else if(Input.GetKeyInputState(BackKey) == INPUTSTATE_PUSH){
		DirFrontBack = -Dir;
	}
	// 
	if(Input.GetKeyInputState(LeftKey) == INPUTSTATE_PUSH){		
		D3DXVec3TransformCoord(&DirLeftRight,&Dir,&rotYMinus);
	}
	// E
	else if(Input.GetKeyInputState(RightKey) == INPUTSTATE_PUSH){
		D3DXVec3TransformCoord(&DirLeftRight,&Dir,&rotYPlus);
	}
	Dir = DirFrontBack + DirLeftRight;
	D3DXVec3Normalize(&Dir,&Dir);

	return Dir;
}

