//---------------------------------------------------//
//	Direct3D`pf
//
//	쐬ҁF		Daiki Terai
//	쐬F		2011/01/29
//	CF	2011/08/01
//---------------------------------------------------//

#ifndef _DIRECT3DMODEL_H_
#define _DIRECT3DMODEL_H_

#include "direct3d9.h"
#include <vector>
#include <map>
#include <string>


// _\tO
enum VERTEXFORMAT
{
	VF_POS		= 1 << 0,	// W
	VF_NORMAL	= 1 << 1,	// @
	VF_TANGENT	= 1 << 2,	// ڐ
	VF_UV		= 1 << 3,	// UV
	VF_COLOR	= 1 << 4,	// _F
	VF_SKIN		= 1 << 5	// XL
};

// _ufBO
typedef struct _VERTEXBLEND_
{
	float	Weight;		// _EFCg
	byte	Indice;		// Ή{[CfbNX
}VERTEXBLEND,*LPVERTEXBLEND;

// _
typedef struct _VERTEX_
{
	D3DXVECTOR3					Pos;		// W
	D3DXVECTOR3					Normal;		// @
	D3DXVECTOR4					Tangent;	// ڐ
	D3DXVECTOR2					UV;			// UV
	D3DXCOLOR					Color;		// _F
	std::vector<VERTEXBLEND>	Blend;		// _ufBO
}VERTEX,*LPVERTEX;

// (Op`)
typedef struct _FACE_
{
	int					MatrialIndex;	// ʂɑΉ}eA̔ԍ
	std::vector<int>	VertexIndex;	// ʂ\钸_̔ԍ
}FACE,*LPFACE;


// eNX`
typedef struct _TEXTURE_
{
	std::basic_string<TCHAR>	ColorTexName;	// J[eNX`
	std::basic_string<TCHAR>	NormalTexName;	// @eNX`
	std::basic_string<TCHAR>	BumpTexName;	// oveNX`
	std::basic_string<TCHAR>	AlphaTexName;	// At@eNX`
}TEXTURE,*LPTEXTURE;

// }eA
typedef struct _MATERIAL_
{
	std::basic_string<TCHAR>	Name;			// }eA
	D3DXCOLOR					Ambient;		// ArGgij 		Cgɑ΂锽ːF
	D3DXCOLOR					Diffuse;		// fBt[YigUˌj 	_ɓlɔ˂鋭xBقǗǂˁB
	D3DXCOLOR					Emissive;		// G~bVuiˌj			CgɊ֌WȂg˂B^ÂȐEł܂B
	float						BumpStrength;	// ovx 					\ʂ̓ʉ̋xBeNX`ƃZbgʁB
	float						Alpha;			// ߓx 						̓ߋBl傫قǕsB
	D3DXCOLOR					Specular;		// XyLiʔˌj		_ɓ̕ɔ˂鋭xBʂ̂悤ȌʁB
	float						Reflect;		//  							}bv̔˓xBl傫قǊ}bv˂̂ŋ̂悤ɂȂB
	TEXTURE						Texture;		// eNX`
}MATERIAL,*LPMATERIAL;

// v~eBui`Pʁj
typedef struct _PRIMITIVE_
{
	int			FaceNum;		// ʐ
	int			StartFaceIndex;	// v~eBůJnԍ(}eA̕ςڂ̖ʔԍ)
	int			MaterialIndex;	// }eAԍ
}PRIMITIVE,*LPPRIMITIVE;

// {[
typedef struct _BONE_
{
	std::basic_string<TCHAR>	Name;		// {[
	D3DXMATRIX					BoneMtx;	// eւ̕ϊs
	_BONE_*						pParent;	// e{[|C^
}BONE,*LPBONE;

// XL
typedef struct _SKIN_
{
	std::basic_string<TCHAR>	BoneName;	// {[
	D3DXMATRIX					OffsetMtx;	// ItZbgs(_ϊs)
}SKIN,*LPSKIN;

// bV
typedef struct _MESH_
{
	std::basic_string<TCHAR>	Name;		// bV
	unsigned int				Format;		// _\tH[}bgtO
	std::vector<VERTEX>			Vertices;	// _	
	std::vector<FACE>			Faces;		// 
	std::vector<PRIMITIVE>		Primitives;	// v~eBu
	std::vector<MATERIAL>		Materials;	// }eA
	std::vector<SKIN>			Skins;		// XL
	LPBONE						pBone;		// bVɊ֘Atꂽ{[
}MESH,*LPMESH;

// L[t[
typedef struct _KEYFRAME_
{
	std::basic_string<TCHAR>					BoneName;		// ֘A{[
	struct{
		std::map<unsigned int,D3DXQUATERNION>	Quaternion;		// ]
		std::map<unsigned int,D3DXVECTOR3>		Scaling;		// XP[O
		std::map<unsigned int,D3DXVECTOR3>		Translation;	// sړ	
	};
	std::map<unsigned int,D3DXMATRIX>			BoneMtx;		// ϊs	
}KEYFRAME,*LPKEYFRAME;

// Aj[VZbg
typedef struct _ANIMATIONSET_
{
	std::basic_string<TCHAR>		Name;		// Aj[VZbg
	unsigned int					MaxKey;		// őL[
	std::vector<KEYFRAME>			KeyFrames;	// L[t[
}ANIMATIONSET,*LPANIMATIONSET;

// fNX
typedef struct _MODEL_
{
	std::map<std::basic_string<TCHAR>,BONE>		Bones;				// {[
	DWORD										AnimTicksPerSecond;	// Aj[VĐx
	std::vector<ANIMATIONSET>					AnimationSets;		// Aj[VZbg
	std::vector<MESH>							Meshs;				// bV
}MODEL,*LPMODEL;



#endif