#include "drawer.h"


// 
bool Drawer::Init(IDirect3DDevice9* pD3DDevice)
{
	// 􉽃IuWFNg
	Geometory::Init(pD3DDevice);

	if(!LoadEffect(pD3DDevice,FX_PLANEPOLYGON))
		return false;
	if(!LoadEffect(pD3DDevice,FX_POINTSPRITE))
		return false;
	if(!LoadEffect(pD3DDevice,FX_MESH))
		return false;
	if(!LoadEffect(pD3DDevice,FX_SKINMESH))
		return false;

	return true;
}
// XvCg`ieNX``j
bool Drawer::DrawPlanePolygon(PlanePolygon& planepolygon,Texture& texture)
{
	const TCHAR* FX = FX_PLANEPOLYGON;

	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effects[FX].GetEffect()->GetDevice(&pD3DDevice);

	// |SsXV
	planepolygon.Update(pD3DDevice);

	// [hϊsZbg
	m_Effects[FX].SetMatrix(_T("g_mWorld"),&planepolygon.m_WorldMtx);
	// tr[|[gϊsZbg
	m_Effects[FX].SetMatrix(_T("g_mToScreen"),&planepolygon.m_ToScreenMtx);
	// UV؂sZbg
	m_Effects[FX].SetMatrix(_T("g_mUV"),&planepolygon.m_UVMtx);
	// eNX`Zbg
	m_Effects[FX].SetTexture(_T("g_Texture1"),texture.GetTexture());
	// ItZbg̃Zbg
	m_Effects[FX].SetVector4(_T("g_Offset"),&D3DXVECTOR4(1.0f/texture.GetWidth(),1.0f/texture.GetHeight(),0.0f,0.0f));
	
	// eNjbÑZbg
	m_Effects[FX].SetTechnique(_T("T0"));
	// GtFNgJn
	m_Effects[FX].Begin();

	// `
	if(!planepolygon.Draw(pD3DDevice))
		return false;

	// GtFNgI
	m_Effects[FX].End();

	// foCX
	SafeRelease(pD3DDevice);
	return true;
}

// |CgXvCg`
bool Drawer::DrawPointSprite(PointSprite& pointsprite,Texture& texture)
{
	const TCHAR* FX = FX_POINTSPRITE;

	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effects[FX].GetEffect()->GetDevice(&pD3DDevice);

	// |CgXvCgsXV
	pointsprite.Update(pD3DDevice);

	// [hϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mWorld"),&pointsprite.m_WorldMtx);
	// r[ϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mView"),&Object3D::m_ViewMtx);
	// ˉeϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mProj"),&Object3D::m_ProjMtx);
	// r[|[g̍ZbgisɂTCYj
	m_Effects[FX].SetFloat(_T("g_ViewportHeight"),pointsprite.m_ViewportHeight);
	// ݎ̐ݒ	
	m_Effects[FX].SetFloat(_T("g_Time"),pointsprite.m_ElapsedTime);
	// x̐ݒ	
	m_Effects[FX].SetVector3(_T("g_Accel"),&pointsprite.m_Accel);
	// eNX`
	m_Effects[FX].SetTexture(_T("g_Texture"),texture.GetTexture());

	// eNjbÑZbg
	m_Effects[FX].SetTechnique(_T("T0"));
	// GtFNgJn
	m_Effects[FX].Begin();

	// `
	if(!pointsprite.Draw(pD3DDevice))
		return false;

	// GtFNgI
	m_Effects[FX].End();

	// foCX
	SafeRelease(pD3DDevice);
	return true;
}

// bV`
bool Drawer::DrawMesh(Mesh& mesh)
{
	const TCHAR* FX = FX_MESH;

	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effects[FX].GetEffect()->GetDevice(&pD3DDevice);

	// sXV
	mesh.Update();
	
	// [hϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mWorld"),&mesh.m_WorldMtx);
	// r[ϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mView"),&Object3D::m_ViewMtx);
	// ˉeϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mProj"),&Object3D::m_ProjMtx);
	// [htϊs̃Zbg
	D3DXMATRIX WorldInvMtx;
	D3DXMatrixInverse(&WorldInvMtx,NULL,&mesh.m_WorldMtx);
	m_Effects[FX].SetMatrix(_T("g_mWorldInv"),&WorldInvMtx);

	
	mesh.SetStream(pD3DDevice);
	for(unsigned int i = 0;i < mesh.m_pData->Primitives.size();++i){

		int MaterialIndex = mesh.m_pData->Primitives[i].MaterialIndex;
		if(mesh.m_pData->Materials[MaterialIndex].Texture.ColorTexName.size() == 0 ){
			// eNjbÑZbg
			m_Effects[FX].SetTechnique(_T("T0"),0);
			m_Effects[FX].SetTexture(_T("g_ColorTex"),NULL);
		}
		else{
			// eNjbÑZbg
			m_Effects[FX].SetTechnique(_T("T0"),1);
			// eNX`̃Zbg
			m_Effects[FX].SetTexture(_T("g_ColorTex"),m_Textures[mesh.m_pData->Materials[MaterialIndex].Texture.ColorTexName].GetTexture());
		}
		// gU
		D3DXVECTOR4 Diffuse = mesh.m_pData->Materials[MaterialIndex].Diffuse;
		m_Effects[FX].SetVector4(_T("g_Diffuse"),&Diffuse);
		// Ȕ
		D3DXVECTOR4 Emissive = mesh.m_pData->Materials[MaterialIndex].Emissive;
		m_Effects[FX].SetVector4(_T("g_Emissive"),&Emissive);

		// GtFNgJn
		m_Effects[FX].Begin();

		// `
		if(!mesh.DrawPrimitive(pD3DDevice,mesh.m_pData,i))
			return false;

		// GtFNgI
		m_Effects[FX].End();
	}
	mesh.ClearStream(pD3DDevice);

	// foCX
	SafeRelease(pD3DDevice);
	return true;
}

// XLbV`
bool Drawer::DrawSkinMesh(Mesh& skinmesh)
{

	const TCHAR* FX = FX_SKINMESH;

	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effects[FX].GetEffect()->GetDevice(&pD3DDevice);

	// sXV
	skinmesh.Update();

	// sX^bNZbg
	m_Effects[FX].SetMatrixArray(_T("g_mFinalTransforms"),&skinmesh.m_MatrixStack[0],skinmesh.m_MatrixStack.size());
	// [hϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mWorld"),&skinmesh.m_WorldMtx);
	// r[ϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mView"),&Object3D::m_ViewMtx);
	// ˉeϊs̃Zbg
	m_Effects[FX].SetMatrix(_T("g_mProj"),&Object3D::m_ProjMtx);
	// [htϊs̃Zbg
	D3DXMATRIX WorldInvMtx;
	D3DXMatrixInverse(&WorldInvMtx,NULL,&skinmesh.m_WorldMtx);
	m_Effects[FX].SetMatrix(_T("g_mWorldInv"),&WorldInvMtx);

	
	skinmesh.SetStream(pD3DDevice);
	for(unsigned int i = 0;i < skinmesh.m_pData->Primitives.size();++i){

		int MaterialIndex = skinmesh.m_pData->Primitives[i].MaterialIndex;
		if(skinmesh.m_pData->Materials[MaterialIndex].Texture.ColorTexName.size() == 0 ){
			// eNjbÑZbg
			m_Effects[FX].SetTechnique(_T("T0"),0);
			m_Effects[FX].SetTexture(_T("g_ColorTex"),NULL);
		}
		else{
			// eNjbÑZbg
			m_Effects[FX].SetTechnique(_T("T0"),1);
			// eNX`̃Zbg
			m_Effects[FX].SetTexture(_T("g_ColorTex"),m_Textures[skinmesh.m_pData->Materials[MaterialIndex].Texture.ColorTexName].GetTexture());
		}
		// gU
		D3DXVECTOR4 Diffuse = skinmesh.m_pData->Materials[MaterialIndex].Diffuse;
		m_Effects[FX].SetVector4(_T("g_Diffuse"),&Diffuse);
		// Ȕ
		D3DXVECTOR4 Emissive = skinmesh.m_pData->Materials[MaterialIndex].Emissive;
		m_Effects[FX].SetVector4(_T("g_Emissive"),&Emissive);

		// GtFNgJn
		m_Effects[FX].Begin();

		// `
		if(!skinmesh.DrawPrimitive(pD3DDevice,skinmesh.m_pData,i))
			return false;

		// GtFNgI
		m_Effects[FX].End();
	}
	skinmesh.ClearStream(pD3DDevice);

	// foCX
	SafeRelease(pD3DDevice);
	return true;
}

// f`
bool Drawer::DrawModel(Model& model)
{
	// fs̍XV
	model.Update();

	for(unsigned int i = 0;i < model.m_Meshs.size();++i){

		// KwbV
		if(model.m_Meshs[i].m_pData->pBone != NULL){
			// ϊς݃[hϊs
			D3DXMATRIX WorldMtx = model.m_ConposedMtx[model.m_Meshs[i].m_pData->pBone->Name] * model.m_WorldMtx;
			model.m_Meshs[i].SetLocalToWorldMatrix(WorldMtx);
		}
		else{
			model.m_Meshs[i].SetLocalToWorldMatrix(model.m_WorldMtx);
		}


		// XLbV
		if(model.m_Meshs[i].m_pData->Skins.size() > 0)
		{
			// sX^bN쐬
			model.m_Meshs[i].CreateMatrixStack(model.m_ConposedMtx);
			// XLbV`
			DrawSkinMesh(model.m_Meshs[i]);
		
		}else{
			// ÓIbV`
			DrawMesh(model.m_Meshs[i]);	
		}
	}

	return true;
}