
#include "window.h"
#include "direct3d9.h"
#include "directinput.h"
#include "drawer.h"
#include "debugcamera.h"
#include "xfileloader.h"

class WindowEx : public Window
{
private:
	Direct3D9		m_Direct3D9;
	DirectInput		m_DirectInput;
	Texture			m_Texture;
	DebugCamera		m_Camera;
	Model			m_Model;
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
    
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// ̓foCX쐬
		m_DirectInput.Create((HINSTANCE)GetModuleHandle(NULL),hWnd);
		// `p
		Drawer::Init(m_Direct3D9.GetDevice());

		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,30,-100),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		
		// Xt@Cǂݍ
		const TCHAR* modelname = _T("miko.x");
		Resource::LoadModel(m_Direct3D9.GetDevice(),modelname);
		m_Model.Create(m_Direct3D9.GetDevice(),Resource::GetModel(modelname));

		m_Model.SetAnimationSet(0);


		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle(){

		// ͍XV
		m_DirectInput.UpdateInputState();
		// JXV
		m_Camera.DebugUpdate(m_DirectInput);
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());

		// ړ擾
		D3DXVECTOR3& Dir = m_Camera.GetMove(m_DirectInput);
		m_Model.UpdateTranslate(Dir);

		if(D3DXVec3Length(&Dir) > 0){
			D3DXVECTOR3 XAxis;
			D3DXVec3Cross(&XAxis,&D3DXVECTOR3(0,1,0),&Dir);
			m_Model.SetRotate(0,atan2(XAxis.z,-XAxis.x),0);
		}
		
		m_Model.SetScale(10,10,10);
		// Aj[VXV
		m_Model.UpdateAnimationKey();

		if(m_Direct3D9.BeginScene()){

			// XN[hԂ
			m_Direct3D9.ScreenClear(0xff000000);
						
			Drawer::DrawGrid(100.0f);
			Drawer::DrawAxis(50.0f);

			Drawer::DrawModel(m_Model);

			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(502);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}