
// O[oȕϐ͒萔WX^ɓ
float4x4	g_mWorld : WORLD;		// [hϊs
float4x4	g_mView	 : VIEW;		// r[ϊs
float4x4	g_mProj  : PROJECTION;	// ˉeϊs
float4x4	g_mWorldInv;			// [htϊs
float3		g_LightDir = {-1.0f,1.0f,1.0f};
float4		g_Diffuse = {1.0f,1.0f,1.0f,1.0f};
float4		g_Emissive = {0.0f,0.0f,0.0f,1.0f};
float4		g_Ambient = {0.2f,0.2f,0.2f,1.0f};

// Tv(J[eNX`)
texture g_ColorTex;
sampler ColorTexSampler
{
	Texture = <g_ColorTex>;
	
	MinFilter = Linear;   MagFilter = Linear;   MipFilter = Linear;
	AddressU  = Wrap;     AddressV  = Wrap;     AddressW  = Wrap;
};


///////////////////////////////////////////////////
//			_VF[_
///////////////////////////////////////////////////

void VS_StaticMeshBasic(in	 float3 in_pos		: POSITION,
						in	 float3 in_normal	: NORMAL,
						out  float4 out_pos		: POSITION,
						out  float4 out_color	: COLOR0
						)
{
	// Wϊ
	float4 pos = mul(float4(in_pos, 1.0f), g_mWorld);
	pos = mul(pos, g_mView);
	out_pos = mul(pos, g_mProj);

	// o[gƖ
	float4 local_light;
	local_light = normalize( mul(float4(normalize(g_LightDir),0.0f),g_mWorldInv));
	out_color = saturate(g_Ambient + g_Emissive + g_Diffuse * max(0,dot(local_light,normalize(in_normal))));
}

void VS_StaticMeshTex(	in	 float3 in_pos		: POSITION,
						in	 float3 in_normal	: NORMAL,
						in	 float2 in_uv		: TEXCOORD0,
						out  float4 out_pos		: POSITION,
						out  float2 out_uv		: TEXCOORD0,
						out  float4 out_color	: COLOR0)
{
	// Wϊ
	float4 pos = mul(float4(in_pos, 1.0f), g_mWorld);
	pos = mul(pos, g_mView);
	out_pos = mul(pos, g_mProj);

	// o[gƖ
	float4 local_light;
	local_light = normalize( mul(float4(normalize(g_LightDir),0.0f),g_mWorldInv));
	out_color = saturate(g_Ambient + g_Emissive + g_Diffuse * max(0,dot(local_light,normalize(in_normal))));

	// UV͂̂܂܏o
	out_uv = in_uv;
}



///////////////////////////////////////////////////
//				sNZVF[_
///////////////////////////////////////////////////

void PS_Basic( 
			 in	 float4 in_color	: COLOR0,
			 out float4 out_color	: COLOR0
			)
{
	// CeBO𔽉f
	out_color = in_color;	
}

void PS_Tex( 
			 in	 float4 in_color	: COLOR0,
			 in	 float2 in_uv		: TEXCOORD0,
			 out float4 out_color	: COLOR0
			)
{
	// CeBOƃeNX`F̃ufBO
	out_color = in_color * tex2D(ColorTexSampler,in_uv);	
}

///////////////////////////////////////////////////
//			eNjbN
///////////////////////////////////////////////////
technique T0
{
	
	// pX̏ォ珇Ԃ0ԁA1ԂƊU肳
	
	// ÓIbV`
	pass StaticMeshBasic
	{	
		VertexShader = compile vs_1_1 VS_StaticMeshBasic();
		PixelShader  = compile ps_2_0 PS_Basic();		
	}	
	
	pass StaticMeshTex
	{	
		VertexShader = compile vs_1_1 VS_StaticMeshTex();
		PixelShader  = compile ps_2_0 PS_Tex();		
	}	
}

