#include "model.h"

// RXgN^
Model::Model() : m_pData(NULL),m_AnimationsetNum(0),m_Key(0)
{}
// fXgN^
Model::~Model()
{
}

// ϊs̍XV
void Model::Update()
{
	// [hϊs쐬
	this->CreateWorldMatrix();

	// Aj[VXV
	this->CreateBoneMatrix();

	// e{[Ƀ[J烏[hւ̕ϊs쐬
	std::map<std::basic_string<TCHAR>,BONE>::iterator it;
	for(it = m_pData->Bones.begin();it != m_pData->Bones.end();++it){
		D3DXMatrixIdentity(&m_ConposedMtx[it->first]);
		LPBONE pBone = &it->second;
		while(pBone != NULL){
			m_ConposedMtx[it->first] *= pBone->BoneMtx;
			pBone = pBone->pParent;
		}
	}
}

// f쐬
bool Model::Create(IDirect3DDevice9* pD3DDevice,LPMODEL pModelData)
{
	if(pModelData == NULL)
		return false;
	m_pData = pModelData;

	// bV쐬
	m_Meshs.resize(m_pData->Meshs.size());
	for(unsigned int i = 0;i < m_pData->Meshs.size();++i){
		m_Meshs[i].Create(pD3DDevice,&m_pData->Meshs[i]);
	}
	// e{[Ƀ[J烏[hւ̕ϊςݍs쐬
	std::map<std::basic_string<TCHAR>,BONE>::iterator it;
	for(it = m_pData->Bones.begin();it != m_pData->Bones.end();++it){
		m_ConposedMtx.insert(std::make_pair(it->first,D3DXMATRIX()));
	}

	return true;
}

// Aj[VL[̃Zbg
void Model::SetAnimationKey(unsigned int Key)
{
	if(m_pData->AnimationSets.size() > 0){
		if(Key >= 0 && Key <= m_pData->AnimationSets[m_AnimationsetNum].MaxKey){
			m_Key = Key;
		}
	}
}

// Aj[VL[̍XV
void Model::UpdateAnimationKey()
{
	m_Key++;

	if(m_pData->AnimationSets.size() > 0){
		if(m_Key > m_pData->AnimationSets[m_AnimationsetNum].MaxKey){
			m_Key = 0;
		}
	}
}

// Aj[VZbg̃Zbg
void Model::SetAnimationSet(unsigned int Number)
{
	if(Number < m_pData->AnimationSets.size()){
		m_AnimationsetNum = Number;
		m_Key = 0;
	}
}


// 2̍s̊Ԃ̐`ԂvZAʂ̍sԂ 
D3DXMATRIX Lerp(D3DXMATRIX a,D3DXMATRIX b,float t)
{
	D3DXMATRIX ret;
	D3DXMatrixIdentity(&ret);
	//ꂼ̍s񂩂畽sړAꂼxNgɎo
	D3DXVECTOR3 vA, vB;
	vA.x=a._41;
	vA.y=a._42;
	vA.z=a._43;
	vB.x=b._41;
	vB.y=b._42;
	vB.z=b._43;
	//ꂼ̍s񂩂XP[OAꂼxNgɎo
	D3DXVECTOR3 vA1(a._11,a._12,a._13);
	float Sax=D3DXVec3Length( &vA1);//XP[OX
	D3DXVECTOR3 vA2(a._21,a._22,a._23);
	float Say=D3DXVec3Length( &vA2);//XP[OY
	D3DXVECTOR3 vA3(a._31,a._32,a._33);
	float Saz=D3DXVec3Length( &vA3);//XP[OZ

	D3DXVECTOR3 vB1(b._11,b._12,b._13);
	float Sbx=D3DXVec3Length( &vB1);//XP[OX
	D3DXVECTOR3 vB2(b._21,b._22,b._23);
	float Sby=D3DXVec3Length( &vB2);//XP[OY
	D3DXVECTOR3 vB3(b._31,b._32,b._33);
	float Sbz=D3DXVec3Length( &vB3);//XP[OZ

	//ꂼ̍s񂩂]AꂼNH[^jIɎo
	//]ƃXP[O͍Ă邽߁A]oOɁAs񂩂XP[OȂĂ͂ȂȂBiꂼXP[OWōsj
	a._11/=Sax;
	a._12/=Sax;
	a._13/=Sax;
	a._21/=Say;
	a._22/=Say;
	a._23/=Say;
	a._31/=Saz;
	a._32/=Saz;
	a._33/=Saz;

	b._11/=Sbx;
	b._12/=Sbx;
	b._13/=Sbx;
	b._21/=Sby;
	b._22/=Sby;
	b._23/=Sby;
	b._31/=Sbz;
	b._32/=Sbz;
	b._33/=Sbz;

	D3DXQUATERNION qA(0,0,0,0);
	D3DXQUATERNION qB(0,0,0,0);
	D3DXQuaternionRotationMatrix(&qA,&a);
	D3DXQuaternionRotationMatrix(&qB,&b);
	//ꂼA̔䗦Ő`Ԃ
	D3DXVECTOR3 vR=(1.0f-t)*vA + t*vB;
	D3DXQUATERNION qR;
	D3DXQuaternionSlerp(&qR,&qA,&qB,t);
	//xNgƃNH[^jIsɖ߂
	D3DXMatrixRotationQuaternion(&ret,&qR);
	ret._41=vR.x;
	ret._42=vR.y;
	ret._43=vR.z;
	ret._44=1.0;

	// XP[O̔䗦Ő`Ԃ
	float Sx = (1.0f-t)*Sax + t*Sbx;
	float Sy = (1.0f-t)*Say + t*Sby;
	float Sz = (1.0f-t)*Saz + t*Sbz;
	ret._11*=Sx;
	ret._12*=Sx;
	ret._13*=Sx;
	ret._21*=Sy;
	ret._22*=Sy;
	ret._23*=Sy;
	ret._31*=Sz;
	ret._32*=Sz;
	ret._33*=Sz;

	return ret;
}

// ݂̃L[t[ɂ{[s̍쐬
void Model::CreateBoneMatrix()
{
	// Aj[VZbg݂Ȃ
	if(m_AnimationsetNum >= m_pData->AnimationSets.size())
		return;

	// L[Aj[VZbg̍őL[𒴂Ă
	if(m_Key > m_pData->AnimationSets[m_AnimationsetNum].MaxKey)
		return;

	// S{[̕ϊs񍷂ւ
	std::vector<KEYFRAME>::iterator it = m_pData->AnimationSets[m_AnimationsetNum].KeyFrames.begin();
	for(;it != m_pData->AnimationSets[m_AnimationsetNum].KeyFrames.end();++it)
	{

	
		//////////////////////////////////
		// L[t[s쐬
		//////////////////////////////////
		// ւs
		D3DXMATRIX ChangeMtx;
		D3DXMatrixIdentity(&ChangeMtx);

		//////////////////////////////////
		// s`łȂ΂g
		//////////////////////////////////
		if(it->BoneMtx.size() > 0)
		{
			
			// L[Ȃ炻̂܂܎g
			if(it->BoneMtx.find(m_Key) != it->BoneMtx.end()){
				ChangeMtx = it->BoneMtx[m_Key];
			}
			// L[ȂȂԂ̃L[Ő`
			else
			{
				// map͓IɃL[Ƀ\[gĂ̂ŏԂɂǂ
				std::map<unsigned int,D3DXMATRIX>::iterator m = it->BoneMtx.begin();
				for(;m != it->BoneMtx.end();++m)
				{
					// L[wL[̔ԍ𒴂
					// ̑ÕL[ƍ̃L[Ő`
					if(m->first > m_Key)
					{
						int	NextKey	= m->first;
						const D3DXMATRIX& Next= m->second;
						m--;
						int	PrevKey = m->first;
						const D3DXMATRIX& Prev= m->second;

						float time = (float)(m_Key - PrevKey) / (NextKey - PrevKey); 
						ChangeMtx = Lerp(Prev,Next,time);
						// ⊮I
						break;
					}
				}
				// Ō܂ōsĂ܂Ō̃L[̂̂g
				if(m == it->BoneMtx.end())
					ChangeMtx = it->BoneMtx.rbegin()->second;

			}
		}
		//////////////////////////////////
		// e퐬ȂA쐬
		//////////////////////////////////
		else
		{
			// ]AXP[OAsړs
			D3DXMATRIX RotateMtx,ScaleMtx,TransMtx;

			///////////////////////////////////
			//	NH[^jI
			///////////////////////////////////
			D3DXQUATERNION quaternion(0.0f,0.0f,0.0f,1.0f);

			// map͓IɃL[Ƀ\[gĂ̂ŏԂɂǂ
			std::map<unsigned int,D3DXQUATERNION >::iterator q = it->Quaternion.begin();
			for(;q != it->Quaternion.end();++q)
			{
				// L[wL[̔ԍ𒴂
				// ̑ÕL[ƍ̃L[Ő`
				if(q->first > m_Key)
				{
					int	NextKey	= q->first;
					const D3DXQUATERNION& Next= q->second;
					q--;
					int	PrevKey = q->first;
					const D3DXQUATERNION& Prev= q->second;

					float time = (float)(m_Key - PrevKey) / (NextKey - PrevKey); 
					quaternion = (1.0f - time) * Prev + time * Next;
					// ⊮I
					break;
				}
			}
			// Ō܂ōsĂ܂Ō̃L[̂̂g
			if(q == it->Quaternion.end())
				quaternion = it->Quaternion.rbegin()->second;

			// nȂ̂w𔽓]
			quaternion.w *= -1;
			// NH[^jI]s쐬
			D3DXMatrixRotationQuaternion(&RotateMtx,&quaternion);

			///////////////////////////////////
			//	XP[O
			///////////////////////////////////
			D3DXVECTOR3 scaling(1.0f,1.0f,1.0f);

			// map͓IɃL[Ƀ\[gĂ̂ŏԂɂǂ
			std::map<unsigned int,D3DXVECTOR3 >::iterator s = it->Scaling.begin();
			for(;s != it->Scaling.end();++s)
			{
				// L[wL[̔ԍ𒴂
				// ̑ÕL[ƍ̃L[Ő`
				if(s->first > m_Key)
				{
					int	NextKey	= s->first;
					const D3DXVECTOR3& Next= s->second;
					s--;
					int	PrevKey = q->first;
					const D3DXVECTOR3& Prev= s->second;

					float t = (float)(m_Key - PrevKey) / (NextKey - PrevKey); 
					scaling = (1.0f - t) * Prev + t * Next;
					// ⊮I
					break;
				}
			}
			// Ō܂ōsĂ܂Ō̃L[̂̂g
			if(s == it->Scaling.end())
				scaling = it->Scaling.rbegin()->second;

			// XP[OXP[Oϊs쐬
			D3DXMatrixScaling(&ScaleMtx,scaling.x,scaling.y,scaling.z);

			///////////////////////////////////
			//	sړ
			///////////////////////////////////
			D3DXVECTOR3 translation(0.0f,0.0f,0.0f);

			// map͓IɃL[Ƀ\[gĂ̂ŏԂɂǂ
			std::map<unsigned int,D3DXVECTOR3>::iterator t = it->Translation.begin();
			for(;t != it->Translation.end();++t)
			{
				// L[wL[̔ԍ𒴂
				// ̑ÕL[ƍ̃L[Ő`
				if(t->first > m_Key)
				{
					int	NextKey	= t->first;
					const D3DXVECTOR3& Next= t->second;
					t--;
					int	PrevKey = t->first;
					const D3DXVECTOR3& Prev= t->second;

					float time = (float)(m_Key - PrevKey) / (NextKey - PrevKey); 
					scaling = (1.0f - time) * Prev + time * Next;
					// ⊮I
					break;
				}
			}
			// Ō܂ōsĂ܂Ō̃L[̂̂g
			if(t == it->Translation.end())
				translation = it->Translation.rbegin()->second;
			
			// sړ畽sړϊs쐬
			D3DXMatrixTranslation(&TransMtx,translation.x,translation.y,translation.z);

			////////////////////////////
			// {[s쐬
			////////////////////////////
			ChangeMtx *= ScaleMtx;
			ChangeMtx *= RotateMtx;
			ChangeMtx *= TransMtx;
		}


		// {[s̍ւ
		m_pData->Bones[it->BoneName].BoneMtx = ChangeMtx;
				
	}
}

