#include "planepolygon.h"

// _\̐錾쐬
bool PlanePolygon::CreateVertexDeclaration(IDirect3DDevice9* pD3DDevice)
{
	if(m_pVertexDecl != NULL)
	{
		ASSERT_MSG(_T("_\̐錾łɑ݂Ă܂\n"));
		return false;
	}

	// _\̒`
	D3DVERTEXELEMENT9 decl[] = 
	{
		{ 0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0, 12, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
		D3DDECL_END()
	};

	// _\̐錾쐬
	if(FAILED(pD3DDevice->CreateVertexDeclaration( decl, &m_pVertexDecl )))
	{
		ASSERT_MSG(_T("_\̐錾쐬Ɏs܂\n"));
		return false;
	}

	return true;
}
// _obt@쐬
bool PlanePolygon::CreateVertexBuffer(IDirect3DDevice9* pD3DDevice,int Width,int Height)
{
	if(m_pVertexBuf!= NULL){
		ASSERT_MSG(_T("_obt@ɑ݂Ă܂\n"));
		return false;
	}

	// _obt@쐬
	LPSPRITE vtx;	// XvCg_
	if(FAILED(pD3DDevice->CreateVertexBuffer(sizeof(SPRITE) * VERTEXNUM, 0, 0, D3DPOOL_MANAGED, &m_pVertexBuf, NULL)))
	{
		ASSERT_MSG(_T("_obt@쐬Ɏs܂\n"));
		return false;
	}
	m_pVertexBuf->Lock(0, 0, (void**)&vtx, 0);

	vtx[0].x = -Width/2.0f;	vtx[0].y = -Height/2.0f;	vtx[0].z = 0.0f;	vtx[0].u = 0.0f; vtx[0].v = 0.0f;
	vtx[1].x = Width/2.0f;	vtx[1].y = -Height/2.0f;	vtx[1].z = 0.0f;	vtx[1].u = 1.0f; vtx[1].v = 0.0f;
	vtx[2].x = -Width/2.0f;	vtx[2].y = Height/2.0f;		vtx[2].z = 0.0f;	vtx[2].u = 0.0f; vtx[2].v = 1.0f;
	vtx[3].x = Width/2.0f;	vtx[3].y = Height/2.0f;		vtx[3].z = 0.0f;	vtx[3].u = 1.0f; vtx[3].v = 1.0f;
	
	m_pVertexBuf->Unlock();

	return true;
}
// CfbNXobt@쐬
bool PlanePolygon::CreateIndexBuffer(IDirect3DDevice9* pD3DDevice)
{
	if(m_pIndexBuf != NULL)
		return false;

	// CfbNXobt@쐬
	// ʂ̐~R
	unsigned short* idx;
	pD3DDevice->CreateIndexBuffer(sizeof(unsigned short) * (PRIMITIVENUM + 2), 
		0, D3DFMT_INDEX16, D3DPOOL_MANAGED, &m_pIndexBuf, NULL);
	m_pIndexBuf->Lock(0, 0, (void**)&idx, 0);

	int count = 0;
	idx[count++] = 0;	idx[count++] = 1;	idx[count++] = 2; idx[count++] = 3;
	
	m_pIndexBuf->Unlock();

	return true;
}
// obt@쐬
bool PlanePolygon::CreateBuffer(IDirect3DDevice9* pD3DDevice)
{
	// _\̐錾쐬
	if(!this->CreateVertexDeclaration(pD3DDevice))
		return false;
	// _obt@쐬
	if(!this->CreateVertexBuffer(pD3DDevice,1,1))
		return false;
	// CfbNXobt@쐬
	if(!this->CreateIndexBuffer(pD3DDevice))
		return false;

	return true;
}
// obt@Zbg
bool PlanePolygon::SetBuffer(IDirect3DDevice9* pD3DDevice)
{
	// _\Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration( m_pVertexDecl )))
		return false;
	// _obt@Zbg
	if(FAILED(pD3DDevice->SetStreamSource(0,m_pVertexBuf,0,sizeof(SPRITE))))
		return false;
	// CfbNXobt@Zbg
	if(FAILED(pD3DDevice->SetIndices(m_pIndexBuf)))
		return false;

	return true;
}

// `
bool PlanePolygon::Draw(IDirect3DDevice9* pD3DDevice)
{
	// obt@Zbg
	if(!this->SetBuffer(pD3DDevice)){
		ASSERT_MSG(_T("obt@̃ZbgɎs܂"));
		return false;
	}

	// `
	if(FAILED(pD3DDevice->DrawIndexedPrimitive(
						D3DPT_TRIANGLESTRIP,// Op`Xgbv
						0, 0,
						VERTEXNUM,			// _
						0,					// JnCfbNXԍ
						PRIMITIVENUM		// ʐ
						)))
	{
		ASSERT_MSG(_T("XvCg`Ɏs܂\n"));
		return false;
	}

	return true;
}

// UV؂s쐬
void PlanePolygon::CreateUVMatrix()
{
	// UV؂s쐬
	D3DXMatrixIdentity(&m_UVMtx);
	m_UVMtx._11 = 1.0f/static_cast<float>(m_DivU);
	m_UVMtx._22 = 1.0f/static_cast<float>(m_DivV);
	m_UVMtx._31 = m_OffsetU/static_cast<float>(m_DivU);
	m_UVMtx._32 = m_OffsetV/static_cast<float>(m_DivV);
}

// RXgN^
PlanePolygon::PlanePolygon()
	:m_pVertexDecl(NULL),m_pVertexBuf(NULL),m_pIndexBuf(NULL),
	m_DivU(1),m_DivV(1),m_OffsetU(0),m_OffsetV(0),m_AnimationNum(0)
{
	D3DXMatrixIdentity(&m_WorldMtx);
	D3DXMatrixIdentity(&m_ToScreenMtx);
	D3DXMatrixIdentity(&m_UVMtx);
}
// fXgN^
PlanePolygon::~PlanePolygon()
{
	SafeRelease(m_pIndexBuf);
	SafeRelease(m_pVertexBuf);
	SafeRelease(m_pVertexDecl);
}


// w
void PlanePolygon::SetDivideUV(int DivU,int DivV){
	if(DivU <= 0 || DivV <= 0)
		return;

	m_Animation.clear();
	m_AnimationName.clear();
	m_AnimationNum = 0;
	m_OffsetU = 0;
	m_OffsetV = 0;
	m_AnimationNum = 0;
	m_DivU = DivU;
	m_DivV = DivV;
}

// UVR}w
void PlanePolygon::SetUV(int OffsetU,int OffsetV){
	if(OffsetU < 0 || OffsetU >= m_DivU)
		return;
	if(OffsetV < 0 || OffsetV >= m_DivV)
		return;

	m_OffsetU = OffsetU;
	m_OffsetV = OffsetV;
	m_AnimationNum = m_OffsetU + m_DivU * OffsetV;
}

// UVAj[Vǉ
bool PlanePolygon::AddAnimationUV(std::basic_string<TCHAR> AnimationName,int Offset,int FrameCount)
{
	if(Offset < 0)
		return false;
	// Aj[VԍUV𒴂ĂZbgs
	if(Offset >= (m_DivU * m_DivV))
		return false;

	// VKAj[V
	if(m_Animation.find(AnimationName) == m_Animation.end()){
		m_Animation.insert(std::make_pair(AnimationName,std::vector<int>()));
		m_Animation[AnimationName].reserve(m_DivU * m_DivV);
	}

	// ǉ
	for(int i = 0;i < FrameCount;++i)
		m_Animation[AnimationName].push_back(Offset);
	m_AnimationName = AnimationName;
	return true;
}
// UVAj[Vǉ
bool PlanePolygon::AddAnimationUV(std::basic_string<TCHAR> AnimationName,int OffsetU,int OffsetV,int FrameCount)
{
	int Offset = OffsetU + OffsetV * m_DivU;
	if(Offset < 0)
		return false;
	// Aj[VԍUV𒴂ĂZbgs
	if(Offset >= (m_DivU * m_DivV))
		return false;
	if(OffsetU >= m_DivU || OffsetV >= m_DivV)
		return false;
	
	// VKAj[V
	if(m_Animation.find(AnimationName) == m_Animation.end()){
		m_Animation.insert(std::make_pair(AnimationName,std::vector<int>()));
		m_Animation[AnimationName].reserve(m_DivU * m_DivV);
	}

	// ǉ
	for(int i = 0;i < FrameCount;++i)
		m_Animation[AnimationName].push_back(Offset);
	m_AnimationName = AnimationName;
	return true;
}
// UVAj[VZbg
bool PlanePolygon::SetAnimation(std::basic_string<TCHAR> AnimationName)
{
	// Aj[VȂ
	if(m_Animation.find(AnimationName) == m_Animation.end()){
		ASSERT_MSG(_T("wUVAj[V݂͑܂\n"));
		return false;
	}
	
	m_AnimationNum = 0;
	m_AnimationName = AnimationName;
	return true;
}

// ݂UVAj[V̎擾
std::basic_string<TCHAR>& PlanePolygon::GetAnimationName()
{
	return m_AnimationName;
}

// UVAj[VXV
void PlanePolygon::UpdateAnimation()
{
	if(m_AnimationNum >= (int)m_Animation[m_AnimationName].size())
		m_AnimationNum = 0;

	m_OffsetU = m_Animation[m_AnimationName][m_AnimationNum] % m_DivU;
	m_OffsetV = m_Animation[m_AnimationName][m_AnimationNum] / m_DivU;
	
	// Aj[Vԍ̍XV
	m_AnimationNum++;
}

// UV㉺ЂԂ
void PlanePolygon::SetTurnV(bool isTurn)
{
	// _obt@쐬
	LPSPRITE vtx;	// XvCg_
	m_pVertexBuf->Lock(0, 0, (void**)&vtx, 0);

	if(isTurn){
		vtx[0].u = 0.0f; vtx[0].v = 1.0f;
		vtx[1].u = 1.0f; vtx[1].v = 1.0f;
		vtx[2].u = 0.0f; vtx[2].v = 0.0f;
		vtx[3].u = 1.0f; vtx[3].v = 0.0f;
	}
	else{
		vtx[0].u = 0.0f; vtx[0].v = 0.0f;
		vtx[1].u = 1.0f; vtx[1].v = 0.0f;
		vtx[2].u = 0.0f; vtx[2].v = 1.0f;
		vtx[3].u = 1.0f; vtx[3].v = 1.0f;
	}

	m_pVertexBuf->Unlock();
}