
// O[oȕϐ͒萔WX^ɓ
float4x4	g_mFinalTransforms[50];		// [JԂ烏[hւ̕ϊs
int			g_NumVertInfluences = 4;	// 1̒_ɉe{[̍ől
float4x4	g_mWorld : WORLD;			// [hϊs
float4x4	g_mView	 : VIEW;			// r[ϊs
float4x4	g_mProj  : PROJECTION;		// ˉeϊs
float4x4	g_mWorldInv;				// [htϊs
float3		g_LightDir = {-1.0f,1.0f,1.0f};
float4		g_Diffuse = {1.0f,1.0f,1.0f,1.0f};
float4		g_Emissive = {0.0f,0.0f,0.0f,1.0f};
float4		g_Ambient = {0.2f,0.2f,0.2f,1.0f};


// Tv(J[eNX`)
texture g_ColorTex;
sampler ColorTexSampler
{
	Texture = <g_ColorTex>;
	
	MinFilter = Linear;   MagFilter = Linear;   MipFilter = Linear;
	AddressU  = Wrap;     AddressV  = Wrap;     AddressW  = Wrap;
};


///////////////////////////////////////////////////
//			_VF[_
///////////////////////////////////////////////////
void VS_SkinMeshBasic(	in float3 in_pos		: POSITION0,
						in float3 in_nor		: NORMAL0,
						in float4 in_weights	: BLENDWEIGHT0,
						in int4   in_indices	: BLENDINDICES0,
						out float4 out_pos		: POSITION0,
						out float4 out_color	: COLOR0
						)
{

    float4 pos = float4(0.0f, 0.0f, 0.0f, 1.0f);
    float3 nor = float3(0.0f, 0.0f, 0.0f);
    float lastWeight = 0.0f;

	// [JԂ烏[hԂ֕ϊ
    int n = g_NumVertInfluences - 1;
    for(int i = 0; i < n; ++i)
    {
        lastWeight += in_weights[i];
	    pos += in_weights[i] * mul(float4(in_pos,1.0f), g_mFinalTransforms[in_indices[i]]);
	    nor += in_weights[i] * mul(in_nor, g_mFinalTransforms[in_indices[i]]);
    }
    lastWeight = 1.0f - lastWeight;
    
    pos += lastWeight * mul(float4(in_pos,1.0f), g_mFinalTransforms[in_indices[n]]);
    nor += lastWeight * mul(in_nor, g_mFinalTransforms[in_indices[n]]);
    pos.w = 1.0f;    	
    nor = normalize(nor);
	
	// Wϊ
	pos = mul(pos, g_mWorld);
	pos = mul(pos, g_mView);
	out_pos = mul(pos, g_mProj);
	
	// o[gƖ
	float4 local_light;
	local_light = normalize( mul(float4(normalize(g_LightDir),0.0f),g_mWorldInv));
	out_color = saturate(g_Ambient + g_Emissive + g_Diffuse * max(0,dot(local_light,nor)));
}

void VS_SkinMeshTex(	in float3 in_pos		: POSITION0,
						in float3 in_nor		: NORMAL0,
						in float2 in_uv			: TEXCOORD0,
						in float4 in_weights	: BLENDWEIGHT0,
						in int4   in_indices	: BLENDINDICES0,
						out float4 out_pos		: POSITION0,
						out float4 out_color	: COLOR0,
						out float2 out_uv		: TEXCOORD0
					)
{

	float4 pos = float4(0.0f, 0.0f, 0.0f, 1.0f);
    float3 nor = float3(0.0f, 0.0f, 0.0f);
    float lastWeight = 0.0f;

	// [JԂ烏[hԂ֕ϊ
    int n = g_NumVertInfluences - 1;
    for(int i = 0; i < n; ++i)
    {
        lastWeight += in_weights[i];
	    pos += in_weights[i] * mul(float4(in_pos,1.0f), g_mFinalTransforms[in_indices[i]]);
	    nor += in_weights[i] * mul(in_nor, g_mFinalTransforms[in_indices[i]]);
    }
    lastWeight = 1.0f - lastWeight;
    
    pos += lastWeight * mul(float4(in_pos,1.0f), g_mFinalTransforms[in_indices[n]]);
    nor += lastWeight * mul(in_nor, g_mFinalTransforms[in_indices[n]]);
    pos.w = 1.0f;    	
    nor = normalize(nor);
	
	// Wϊ
	pos = mul(pos, g_mWorld);
	pos = mul(pos, g_mView);
	out_pos = mul(pos, g_mProj);
	
	// o[gƖ
	float4 local_light;
	local_light = normalize( mul(float4(normalize(g_LightDir),0.0f),g_mWorldInv));
	out_color = saturate(g_Ambient + g_Emissive + g_Diffuse * max(0,dot(local_light,nor)));

	// UV͂̂܂܏o
	out_uv = in_uv;
}


///////////////////////////////////////////////////
//				sNZVF[_
///////////////////////////////////////////////////
void PS_Basic( 
			 in	 float4 in_color	: COLOR0,
			 out float4 out_color	: COLOR0
			)
{
	// CeBO𔽉f
	out_color = in_color;	
}

void PS_Tex( 
			 in	 float4 in_color	: COLOR0,
			 in	 float2 in_uv		: TEXCOORD0,
			 out float4 out_color	: COLOR0
			)
{
	// CeBOƃeNX`F̃ufBO
	out_color = in_color * tex2D(ColorTexSampler,in_uv);	
}

///////////////////////////////////////////////////
//			eNjbN
///////////////////////////////////////////////////
technique T0
{
	// pX̏ォ珇Ԃ0ԁA1ԂƊU肳
	
	// XLbV`
	pass SkinMeshBasic
	{	
		VertexShader = compile vs_1_1 VS_SkinMeshBasic();
		PixelShader  = compile ps_2_0 PS_Basic();		
	}	
	
	pass SkinMeshTex
	{	
		VertexShader = compile vs_1_1 VS_SkinMeshTex();
		PixelShader  = compile ps_2_0 PS_Tex();		
	}	
}

