#define _CRT_SECURE_NO_WARNINGS
#define _CRT_NON_CONFORMING_SWPRINTFS
#include "stream.h"



// _obt@̍쐬
bool Stream::CreateVertexBuf(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh,unsigned int Flag)
{
	LPDIRECT3DVERTEXBUFFER9 vtxBuf;
	unsigned int vertexNum = (UINT)pMesh->Vertices.size();

	if(Flag & STREAM_POSNOR0)
	{
		LPVERTEXPOSNOR v;
		pD3DDevice->CreateVertexBuffer(sizeof(VERTEXPOSNOR) * vertexNum, 0, 0, D3DPOOL_MANAGED, &vtxBuf, NULL);
		vtxBuf->Lock(0, 0, (void**)&v, 0);

		for(unsigned int i = 0;i < vertexNum;++i)
		{
			memcpy(&v[i].Pos,&pMesh->Vertices[i].Pos,sizeof(D3DXVECTOR3));
			memcpy(&v[i].Nor,&pMesh->Vertices[i].Normal,sizeof(D3DXVECTOR3));
		}

		vtxBuf->Unlock();
		m_VertexBuffer.push_back(vtxBuf);
		m_BufSize.push_back(sizeof(VERTEXPOSNOR));
		return true;
	}

    if(Flag & STREAM_TANGENT)
	{
		LPVERTEXTANGENT v;
		pD3DDevice->CreateVertexBuffer(sizeof(VERTEXTANGENT) * vertexNum, 0, 0, D3DPOOL_MANAGED, &vtxBuf, NULL);
		vtxBuf->Lock(0, 0, (void**)&v, 0);

		for(unsigned int i = 0;i < vertexNum;++i)
		{
			memcpy(&v[i].Tangent,&pMesh->Vertices[i].Tangent,sizeof(D3DXVECTOR3));
		}

		vtxBuf->Unlock();
		m_VertexBuffer.push_back(vtxBuf);
		m_BufSize.push_back(sizeof(VERTEXTANGENT));
		return true;
	}

	if(Flag & STREAM_UV)
	{
		LPVERTEXUV v;
		pD3DDevice->CreateVertexBuffer(sizeof(VERTEXUV) * vertexNum, 0, 0, D3DPOOL_MANAGED, &vtxBuf, NULL);
		vtxBuf->Lock(0, 0, (void**)&v, 0);

		for(unsigned int i = 0;i < vertexNum;++i)
		{
			memcpy(&v[i].UV,&pMesh->Vertices[i].UV,sizeof(D3DXVECTOR2));
		}

		vtxBuf->Unlock();
		m_VertexBuffer.push_back(vtxBuf);
		m_BufSize.push_back(sizeof(VERTEXUV));
		return true;
	}

	if(Flag & STREAM_COLOR)
	{
		LPVERTEXCOLOR v;
		pD3DDevice->CreateVertexBuffer(sizeof(VERTEXCOLOR) * vertexNum, 0, 0, D3DPOOL_MANAGED, &vtxBuf, NULL);
		vtxBuf->Lock(0, 0, (void**)&v, 0);

		for(unsigned int i = 0;i < vertexNum;++i)
		{
			v[i].Color = pMesh->Vertices[i].Color;
		}

		vtxBuf->Unlock();
		m_VertexBuffer.push_back(vtxBuf);
		m_BufSize.push_back(sizeof(VERTEXCOLOR));
		return true;
	}


	if(Flag & STREAM_SKIN)
	{
		LPVERTEXSKIN v;
		pD3DDevice->CreateVertexBuffer(sizeof(VERTEXSKIN) * vertexNum, 0, 0, D3DPOOL_MANAGED, &vtxBuf, NULL);
		vtxBuf->Lock(0, 0, (void**)&v, 0);

		// bV̑S_
		for(unsigned int i = 0;i < vertexNum;++i)
		{
			// XL̐
			for(unsigned int j = 0;j < BLENDMAX;++j)
			{
				
				// _ufBȌ񂪃ufBO܂łȂ
				if(j >= pMesh->Vertices[i].Blend.size())
				{
					v[i].Indices[j] = 0;	// KȃCfbNX
					v[i].Weights[j] = 0.0f;	// EFCg0ƂĈidvj
				}
				else
				{
					v[i].Indices[j] = pMesh->Vertices[i].Blend[j].Indice;	
					v[i].Weights[j] = pMesh->Vertices[i].Blend[j].Weight;	
				}
				
			}
		}

		vtxBuf->Unlock();
		m_VertexBuffer.push_back(vtxBuf);
		m_BufSize.push_back(sizeof(VERTEXSKIN));
		return true;
	}

	return false;
}

// CfbNXobt@̍쐬
bool Stream::CreateIndexBuf(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh)
{

	// CfbNXobt@쐬
	// ʂ̐~R
	unsigned short* idx;
	if(FAILED(pD3DDevice->CreateIndexBuffer(sizeof(unsigned short) * 3 * pMesh->Faces.size(), 
		0, D3DFMT_INDEX16, D3DPOOL_MANAGED, &m_IndexBuffer, NULL))){
		ASSERT_MSG(_T("CfbNXobt@쐬Ɏs܂\n"));
		return false;
	}
	m_IndexBuffer->Lock(0, 0, (void**)&idx, 0);

	int count = 0;
	for(unsigned int i = 0;i < pMesh->Faces.size();i++)
	{
		idx[count++] = pMesh->Faces[i].VertexIndex[0];
		idx[count++] = pMesh->Faces[i].VertexIndex[1];
		idx[count++] = pMesh->Faces[i].VertexIndex[2];
	}

	m_IndexBuffer->Unlock();
	return true;
}


// Xg[̍쐬
bool Stream::CreateStream(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh,unsigned int Flag)
{
	int								StreamCount = 0;	// Xg[
	std::vector<D3DVERTEXELEMENT9>	Elements;			// _\̂\vf

	// _ʒuA@
	if(Flag & STREAM_POSNOR0)
	{
		WORD OffSet = 0;	// Xg[擪̃ItZbg
		D3DVERTEXELEMENT9 element;
		element.Stream		= StreamCount;
        element.Offset		= 0;
		element.Type		= D3DDECLTYPE_FLOAT3;
		element.Method		= D3DDECLMETHOD_DEFAULT;
		element.Usage		= D3DDECLUSAGE_POSITION;
		element.UsageIndex	= 0;

		OffSet += sizeof(float) * 3;
		Elements.push_back(element);

		element.Stream		= StreamCount;
        element.Offset		= OffSet;
        element.Type		= D3DDECLTYPE_FLOAT3;
        element.Method		= D3DDECLMETHOD_DEFAULT;
        element.Usage		= D3DDECLUSAGE_NORMAL;
        element.UsageIndex	= 0;

        Elements.push_back(element);
		StreamCount++;

		// _obt@쐬
        this->CreateVertexBuf(pD3DDevice,pMesh,STREAM_POSNOR0);
	}


	// ڐ
	if(Flag & STREAM_TANGENT)
	{
		D3DVERTEXELEMENT9 element;
		element.Stream		= StreamCount;
		element.Offset		= 0;
		element.Type		= D3DDECLTYPE_FLOAT3;
		element.Method		= D3DDECLMETHOD_DEFAULT;
		element.Usage		= D3DDECLUSAGE_TANGENT;
		element.UsageIndex	= 0;

		Elements.push_back(element);
		StreamCount++;

		// _obt@쐬
		this->CreateVertexBuf(pD3DDevice,pMesh,STREAM_TANGENT);
	}


	// UV
	if(Flag & STREAM_UV)
	{
		D3DVERTEXELEMENT9 element;
		element.Stream		= StreamCount;
		element.Offset		= 0;
		element.Type		= D3DDECLTYPE_FLOAT2;
		element.Method		= D3DDECLMETHOD_DEFAULT;
		element.Usage		= D3DDECLUSAGE_TEXCOORD;
		element.UsageIndex	= 0;

		Elements.push_back(element);
		StreamCount++;

		// _obt@쐬
		this->CreateVertexBuf(pD3DDevice,pMesh,STREAM_UV);
	}


	// _J[
	if(Flag & STREAM_COLOR)
	{
		D3DVERTEXELEMENT9 element;
		element.Stream		= StreamCount;
		element.Offset		= 0;
		element.Type		= D3DDECLTYPE_D3DCOLOR;
		element.Method		= D3DDECLMETHOD_DEFAULT;
		element.Usage		= D3DDECLUSAGE_COLOR;
		element.UsageIndex	= 0;

		Elements.push_back(element);
		StreamCount++;

		// _obt@쐬
		this->CreateVertexBuf(pD3DDevice,pMesh,STREAM_COLOR);
	}

	// XL
	if(Flag & STREAM_SKIN)
	{
		WORD OffSet = 0;	// Xg[擪̃ItZbg
		D3DVERTEXELEMENT9 element;
		element.Stream		= StreamCount;
		element.Offset		= OffSet;
		element.Type		= D3DDECLTYPE_FLOAT4;
		element.Method		= D3DDECLMETHOD_DEFAULT;
		element.Usage		= D3DDECLUSAGE_BLENDWEIGHT;
		element.UsageIndex	= 0;

		OffSet += sizeof(float) * 4;
		Elements.push_back(element);

		memset(&element,0,sizeof(D3DVERTEXELEMENT9));
		element.Stream		= StreamCount;
		element.Offset		= OffSet;
		element.Type		= D3DDECLTYPE_UBYTE4;
		element.Method		= D3DDECLMETHOD_DEFAULT;
		element.Usage		= D3DDECLUSAGE_BLENDINDICES;
		element.UsageIndex	= 0;

		Elements.push_back(element);
		StreamCount++;

		// _obt@쐬
		this->CreateVertexBuf(pD3DDevice,pMesh,STREAM_SKIN);
	}
	
	// _\̂̍Ō͕KD3DDECL_END
	D3DVERTEXELEMENT9 element = D3DDECL_END();
	Elements.push_back(element);

	
	// _^쐬
	if(FAILED(pD3DDevice->CreateVertexDeclaration(&Elements[0], &m_Declaration))){
		ASSERT_MSG(_T("_\̐錾쐬Ɏs܂\n"));
		return false;
	}

	// CfbNXobt@쐬
	this->CreateIndexBuf(pD3DDevice,pMesh);

	return true;
}


// Xg[Zbg
bool Stream::SetStream(IDirect3DDevice9* pD3DDevice)
{
	// _錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration( m_Declaration ))){
		ASSERT_MSG(_T("_\̐錾ZbgɎs܂\n"));
		return false;
	}    

	// CfbNXobt@̃Zbg
	if(FAILED(pD3DDevice->SetIndices(m_IndexBuffer))){
		ASSERT_MSG(_T("CfbNXobt@ZbgɎs܂\n"));
		return false;
	}
	
	// Xg[̃Zbg
	for(unsigned int i = 0;i < m_VertexBuffer.size();++i){
		if(FAILED(pD3DDevice->SetStreamSource( i, m_VertexBuffer[i], 0, m_BufSize[i] ))){
			ASSERT_MSG(tformat(_T("_obt@(%dԖ)ZbgɎs܂\n"),i).c_str());
			return false;
		}
	}

	return true;
}

// Xg[NA
bool Stream::ClearStream(IDirect3DDevice9* pD3DDevice)
{
	// Xg[̃NA
	for(unsigned int i = 0;i < m_VertexBuffer.size();++i){
		if(FAILED(pD3DDevice->SetStreamSource( i, NULL, 0, 0 ))){
			ASSERT_MSG(_T("Xg[̃NAɎs܂\n"));
			return false;
		}
	}
	return true;
}

// v~eBu`
bool Stream::DrawPrimitive(IDirect3DDevice9* pD3DDevice,const LPMESH pMesh,int PrimitiveNum)
{
	// `
	if(FAILED(pD3DDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0,
		(UINT)pMesh->Vertices.size(),
		(UINT)pMesh->Primitives[PrimitiveNum].StartFaceIndex * 3,
		(UINT)pMesh->Primitives[PrimitiveNum].FaceNum)))
	{
		ASSERT_MSG(_T("v~eBu`掸s\n"));
		return false;
	}

	return true;
}

// RXgN^
Stream::Stream()
	:m_Declaration(NULL),m_IndexBuffer(NULL)
{
}

// fXgN^
Stream::~Stream()
{
	SafeRelease(m_IndexBuffer);
	for(unsigned int i = 0;i < m_VertexBuffer.size();++i)
		SafeRelease(m_VertexBuffer[i]);
	SafeRelease(m_Declaration);
}
