#include "swapchain.h"

// RXgN^
SwapChain::SwapChain():m_hWnd(NULL),m_pSwapChain(NULL),m_pBackBufferSurface(NULL),m_pBackBufferDepthStencilSurface(NULL)
{
	memset(&m_SurfInfo,0,sizeof(D3DSURFACE_DESC));
}

// fXgN^
SwapChain::~SwapChain()
{
	SafeRelease(m_pSwapChain);
	SafeRelease(m_pBackBufferSurface);
	SafeRelease(m_pBackBufferDepthStencilSurface);
}

// Xbv`FC쐬
void SwapChain::Create(IDirect3DDevice9* pD3DDevice,HWND hWnd,int Width,int Height,D3DPRESENT_PARAMETERS* pD3DParam)
{
	D3DPRESENT_PARAMETERS D3DParam = *pD3DParam;
	
	D3DParam.Windowed				= TRUE;		// EBhE[h
	D3DParam.BackBufferWidth		= Width;	// obNobt@
	D3DParam.BackBufferHeight		= Height;	// obNobt@
	D3DParam.hDeviceWindow			= hWnd;		// EBhẼnh

	m_hWnd = hWnd;	// EBhEnh

	// Xbv`FC쐬
	pD3DDevice->CreateAdditionalSwapChain( &D3DParam, &m_pSwapChain );

	// obNobt@T[tFCX擾
	m_pSwapChain->GetBackBuffer( 0, D3DBACKBUFFER_TYPE_MONO, &m_pBackBufferSurface );
	// T[tFCX擾
	m_pBackBufferSurface->GetDesc( &m_SurfInfo );
	// [xobt@T[tFCX쐬
	pD3DDevice->CreateDepthStencilSurface(m_SurfInfo.Width,m_SurfInfo.Height,D3DFMT_D24S8,D3DMULTISAMPLE_NONE,0,TRUE,&m_pBackBufferDepthStencilSurface,NULL);
		
}

// obNobt@T[tFCX擾
IDirect3DSurface9* SwapChain::GetBackBufferSurface()
{
	return m_pBackBufferSurface;
}
// obNobt@[xobt@T[tFCX擾
IDirect3DSurface9* SwapChain::GetBackBufferDepthStencilSurface()
{
	return m_pBackBufferDepthStencilSurface;
}
// T[tFCX擾
int SwapChain::GetWidth()
{
	return m_SurfInfo.Width;
}
// T[tFCX擾
int SwapChain::GetHeight()
{
	return m_SurfInfo.Height;
}

// ʍXV
HRESULT SwapChain::Present(){
	return m_pSwapChain->Present(NULL,NULL,m_hWnd,NULL,0);
}

