#include "texture.h"
#pragma warning(disable:4996)

// RXgN^
Texture::Texture()
	:m_pTex(NULL),m_pSurf(NULL),m_pDepthStencilSurf(NULL),m_pSystemSurf(NULL),
	m_TexWidth(0),m_TexHeight(0)
{}

// Rs[RXgN^
Texture::Texture(const Texture& obj)
	:m_pTex(NULL),m_pSurf(NULL),m_pDepthStencilSurf(NULL),m_pSystemSurf(NULL),
	m_TexWidth(0),m_TexHeight(0)
{
	this->Copy(&obj);
}
// =Zq̃I[o[[h
Texture& Texture::operator=(const Texture& obj)
{
	this->Copy(&obj);
	return *this;
}

// Rs[(narrow copy)
bool Texture::Copy(const Texture* pTex)
{
	if(pTex->m_pTex == NULL)
		return false;

	SafeRelease(m_pSurf); 
	SafeRelease(m_pTex);

	// eNX`Rs[
	m_pTex = pTex->m_pTex;
	m_pTex->AddRef();	// dvFQƃJE^𑝂₷
	// eNX`T[tFCX擾
	m_pTex->GetSurfaceLevel( 0, &m_pSurf );   // T[tFCX擾

	// T[tFCX񂩂摜TCY擾
	D3DSURFACE_DESC SurfaceInfo;
	m_pSurf->GetDesc( &SurfaceInfo );
	m_TexWidth = SurfaceInfo.Width;     // isNZj
	m_TexHeight = SurfaceInfo.Height;   // isNZj

	// _[eNX`̏ꍇ
	if(pTex->m_pDepthStencilSurf != NULL){
		// [xobt@T[tFCXRs[
		m_pDepthStencilSurf = pTex->m_pDepthStencilSurf;
		m_pDepthStencilSurf->AddRef();// dvFQƃJE^𑝂₷
	}
	if(pTex->m_pSystemSurf != NULL){
		// VXeT[tFCXRs[
		m_pSystemSurf = pTex->m_pSystemSurf;
		m_pSystemSurf->AddRef();// dvFQƃJE^𑝂₷
	}

	return true;
}

// fXgN^
Texture::~Texture(){
	SafeRelease(m_pSystemSurf);
	SafeRelease(m_pDepthStencilSurf);
	SafeRelease(m_pSurf);
	SafeRelease(m_pTex);
}


// T[tFCX擾
void Texture::GetSurfaceInfo(D3DSURFACE_DESC* pOutSurfaceInfo)
{
	// eNX`T[tFCX擾
	m_pTex->GetSurfaceLevel( 0, &m_pSurf );   // T[tFCX擾

	// T[tFCX񂩂摜TCY擾
	m_pSurf->GetDesc( pOutSurfaceInfo );
	m_TexWidth = pOutSurfaceInfo->Width;     // isNZj
	m_TexHeight = pOutSurfaceInfo->Height;   // isNZj
}

// eNX`쐬
bool Texture::Create(IDirect3DDevice9* pD3DDevice,int Width,int Height,bool isRenderTarget,D3DFORMAT Format)
{
	if(m_pTex != NULL)
		return false;


	DWORD Usage = 0;
	D3DPOOL Pool = D3DPOOL_MANAGED;

	// _[eNX`̏ꍇ
	if(isRenderTarget){
		Usage = D3DUSAGE_RENDERTARGET;
		Pool = D3DPOOL_DEFAULT;
	}


	if(FAILED(pD3DDevice->CreateTexture(
		Width,				// 
		Height,				// 
		1,					// ~bv}bvxiLevel 1j
		Usage,				// gppr
		Format,				// eNX`[J[tH[}bg
		Pool,				// foCXۑ`
		&m_pTex,			// 󂯎eNX`C^[tF[X
		NULL))){
		ASSERT_MSG(_T("eNX`쐬Ɏs܂"));
		return false;
	}

	D3DSURFACE_DESC SurfaceInfo;
	this->GetSurfaceInfo(&SurfaceInfo);

	// _[eNX`̏ꍇ
	if(isRenderTarget){
		// [xobt@T[tFCX쐬
		pD3DDevice->CreateDepthStencilSurface(SurfaceInfo.Width,SurfaceInfo.Height,D3DFMT_D24S8,D3DMULTISAMPLE_NONE,0,TRUE,&m_pDepthStencilSurf,NULL);
		// _[eNX`ƓtH[}bg̃T[tFCXVXeɊm
		pD3DDevice->CreateOffscreenPlainSurface(SurfaceInfo.Width, SurfaceInfo.Height, SurfaceInfo.Format,D3DPOOL_SYSTEMMEM,&m_pSystemSurf,NULL);	
	}

	return true;
}

// eNX`쐬it@Cǂݍ݁j
bool Texture::Create(const TCHAR* FileName,IDirect3DDevice9* pD3DDevice,int Width,int Height,DWORD ColorKey,D3DFORMAT Format){

	if(m_pTex != NULL)
		return false;

	DWORD Usage = 0;
	D3DPOOL Pool = D3DPOOL_MANAGED;

	// Exo[WgȂ2ׂ̂̃TCYɏɊg傳Ă܂̂Œ
	if(FAILED(D3DXCreateTextureFromFileEx( pD3DDevice,FileName,
		Width,				// 
		Height,				// 
		1,					// ~bv}bvxiLevel 1j
		Usage,				// gppr
		Format,				// eNX`[J[tH[}bg
		Pool,				// foCXۑ`
		D3DX_FILTER_LINEAR,	// tB^[
		D3DX_FILTER_LINEAR,	// ~bv}bvtB^[
		ColorKey,			// J[L[
		NULL,
		NULL,
		&m_pTex				// 󂯎eNX`C^[tF[X
		))){
		ASSERT_MSG(_T("eNX`쐬Ɏs܂"));
		return false;
	}
	// eNX`T[tFCX擾
	m_pTex->GetSurfaceLevel( 0, &m_pSurf );   // T[tFCX擾

	D3DSURFACE_DESC SurfaceInfo;
	this->GetSurfaceInfo(&SurfaceInfo);

	return true;
}

// eNX`쐬it@Cǂݍ݁j
bool Texture::Create(const TCHAR* FileName,IDirect3DDevice9* pD3DDevice)
{
	// 2ׂ̂̃TCYɏɊg傳Ă܂̂Œ
	if(FAILED(D3DXCreateTextureFromFile( pD3DDevice,FileName ,&m_pTex))){
		ASSERT_MSG(_T("eNX`쐬Ɏs܂"));
		return false;
	}

	D3DSURFACE_DESC SurfaceInfo;
	this->GetSurfaceInfo(&SurfaceInfo);

	return true;
}


// eNX`쐬iǂݍ݁j
bool Texture::Create(const BYTE* pData,DWORD DataSize,IDirect3DDevice9* pD3DDevice,int Width,int Height,DWORD ColorKey,D3DFORMAT Format)
{
	if(m_pTex != NULL)
		return false;

	DWORD Usage = 0;
	D3DPOOL Pool = D3DPOOL_MANAGED;

	// Exo[WgȂ2ׂ̂̃TCYɏɊg傳Ă܂̂Œ
	if(FAILED(D3DXCreateTextureFromFileInMemoryEx( pD3DDevice,
		pData,				// f[^擪|C^
		DataSize,			// f[^TCY
		Width,				// 
		Height,				// 
		1,					// ~bv}bvxiLevel 1j
		Usage,				// gppr
		Format,				// eNX`[J[tH[}bg
		Pool,				// foCXۑ`
		D3DX_FILTER_LINEAR,	// tB^[
		D3DX_FILTER_LINEAR,	// ~bv}bvtB^[
		ColorKey,			// J[L[
		NULL,
		NULL,
		&m_pTex				// 󂯎eNX`C^[tF[X
		))){
		ASSERT_MSG(_T("eNX`쐬Ɏs܂"));
		return false;
	}

	D3DSURFACE_DESC SurfaceInfo;
	this->GetSurfaceInfo(&SurfaceInfo);
	
	return true;
}

// eNX`쐬iǂݍ݁j
bool Texture::Create(const BYTE* pData,DWORD DataSize,IDirect3DDevice9* pD3DDevice)
{
	// 2ׂ̂̃TCYɏɊg傳Ă܂̂Œ
	if(FAILED(D3DXCreateTextureFromFileInMemory( pD3DDevice,pData,DataSize ,&m_pTex))){
		ASSERT_MSG(_T("eNX`쐬Ɏs܂"));
		return false;
	}

	D3DSURFACE_DESC SurfaceInfo;
	this->GetSurfaceInfo(&SurfaceInfo);

	return true;
}

// eNX`쐬i\[Xǂݍ݁j
bool Texture::Create(int ResourceID,IDirect3DDevice9* pD3DDevice,int Width,int Height,DWORD ColorKey,D3DFORMAT Format)
{
	if(m_pTex != NULL)
		return false;

	DWORD Usage = 0;
	D3DPOOL Pool = D3DPOOL_MANAGED;
		
	// Exo[WgȂ2ׂ̂̃TCYɏɊg傳Ă܂̂Œ
	if(FAILED(D3DXCreateTextureFromResourceEx( pD3DDevice,
		NULL,						// W[nh
		MAKEINTRESOURCE(ResourceID),// \[XID
		Width,						// 
		Height,						// 
		1,							// ~bv}bvxiLevel 1j
		Usage,						// gppr
		Format,						// eNX`[J[tH[}bg
		Pool,						// foCXۑ`
		D3DX_FILTER_LINEAR,			// tB^[
		D3DX_FILTER_LINEAR,			// ~bv}bvtB^[
		ColorKey,					// J[L[
		NULL,
		NULL,
		&m_pTex				// 󂯎eNX`C^[tF[X
		))){
		ASSERT_MSG(_T("eNX`쐬Ɏs܂"));
		return false;
	}

	D3DSURFACE_DESC SurfaceInfo;
	this->GetSurfaceInfo(&SurfaceInfo);

	return true;
}

// eNX`쐬i\[Xǂݍ݁j
bool Texture::Create(int ResourceID,IDirect3DDevice9* pD3DDevice)
{
	// 2ׂ̂̃TCYɏɊg傳Ă܂̂Œ
	if(FAILED(D3DXCreateTextureFromResource( pD3DDevice,NULL,MAKEINTRESOURCE(ResourceID),&m_pTex))){
		ASSERT_MSG(_T("eNX`쐬Ɏs܂"));
		return false;
	}

	D3DSURFACE_DESC SurfaceInfo;
	this->GetSurfaceInfo(&SurfaceInfo);

	return true;
}


// eNX`ۑiBMPt@Cój
bool Texture::Save(const TCHAR* FileName)
{
	if(FAILED(D3DXSaveTextureToFile(FileName,D3DXIFF_BMP,m_pTex,NULL) )){
		ASSERT_MSG(_T("eNX`ۑɎs܂"));
		return false;
	}

	return true;
}

// eNX`擾
IDirect3DTexture9* Texture::GetTexture(){
	return m_pTex;
}
// T[tFX擾
IDirect3DSurface9* Texture::GetSurface(){
	return m_pSurf;
}
// [xobt@T[tFX擾
IDirect3DSurface9* Texture::GetDepthStencilSurface(){
	return m_pDepthStencilSurf;
}
// 擾
int	Texture::GetWidth(){
	return m_TexWidth;
}
// 擾
int Texture::GetHeight(){
	return m_TexHeight;
}


// eNX`bN
D3DLOCKED_RECT* Texture::Lock(){
	if(FAILED(m_pTex->LockRect( 0, &m_TexRect, NULL, 0 ))){
		// bNłeNX``łȂ
		ASSERT_MSG(_T("eNX`bNł܂"));
		return NULL;
	}

	return &m_TexRect;
}

// eNX`AbN
void Texture::UnLock(){
	m_pTex->UnlockRect(0);
}

// _[^[Qbgp̃eNX`̓bNłȂ̂
// rfIVXeɃT[tFCXRs[
D3DLOCKED_RECT* Texture::RenderTextureLock(IDirect3DDevice9* pD3DDevice)
{
	// _[^[Qbg̃T[tFCXrfIVXeɓ]
	if(FAILED(pD3DDevice->GetRenderTargetData(m_pSurf, m_pSystemSurf))){
		ASSERT_MSG(_T("rfIVXe]Ɏs܂"));
		return NULL;
	}

	// T[tFCXbN
	m_pSystemSurf->LockRect(&m_TexRect, NULL, 0);

	return &m_TexRect;
}

// _[eNX`AbN
// foCXnƂ̓T[tFCXXV܂
void Texture::RenderTextureUnLock(IDirect3DDevice9* pD3DDevice)
{
	// T[tFCXbN
	m_pSystemSurf->UnlockRect();

	if(pD3DDevice != NULL){
		// _[eNX`̃T[tFCX`ς
		if(FAILED(pD3DDevice->UpdateSurface(m_pSystemSurf, NULL, m_pSurf, NULL))){
			ASSERT_MSG(_T("T[tFX̃rfI]Ɏs܂"));
		}
	}

}



