#define _CRT_SECURE_NO_WARNINGS
#include "wave.h"

// RXgN^
Wave::Wave()
{}

// fXgN^
Wave::~Wave()
{}

//	Wave t@Cǂݍ
bool Wave::Load( const TCHAR* FileName)
{
	
	// oCiǂݍ݃[hŊJ
	FILE* fp;
	if (!(fp = ::_tfopen(FileName, _T("rb") )))
		return false;


	char chunkId[5] = {};
	char tmp[5] = {};
	unsigned int chunkSize = 0;

	// RIFF`Nǂݍ
	if (::fread(chunkId, sizeof(char) * 4, 1, fp) != 1)
		return false;

	if (::fread(&chunkSize, sizeof(unsigned int), 1, fp) != 1)
		return false;

	if (::fread(tmp, sizeof(char) * 4, 1, fp) != 1)
		return false;

	if (::strcmp(chunkId, "RIFF") || ::strcmp(tmp, "WAVE"))
	{
		return false;
	}

	// q`Nǂݍ
	bool fmtchunk	= false;
	bool datachunk	= false;
	while (true)
	{
		if (::fread(chunkId, sizeof(char) * 4, 1, fp) != 1)
			return false;

		if (::fread(&chunkSize, sizeof(unsigned int), 1, fp) != 1)
			return false;

		if (!::strcmp(chunkId, "fmt "))
		{
			if (chunkSize >= sizeof(WAVEFORMATEX))
			{
				if (::fread(&m_Format, sizeof(WAVEFORMATEX), 1, fp) != 1)
					return false;

				int diff = chunkSize - sizeof(WAVEFORMATEX);
				::fseek(fp, diff, SEEK_CUR);
			}
			else
			{
				::memset(&m_Format, 0, sizeof(WAVEFORMATEX));
				if (::fread(&m_Format, chunkSize, 1, fp) != 1)
					return false;
			}
			fmtchunk = true;
		}
		else if (!::strcmp(chunkId, "data"))
		{
			// f[^TCYm
			m_Data.resize(chunkSize);
			// f[^ǂݍ
			if (::fread(&m_Data[0], sizeof(byte), chunkSize, fp) != chunkSize)
			{
				fclose(fp);
				return false;
			}
			datachunk = true;
		}
		else
		{
			::fseek(fp, chunkSize, SEEK_CUR);
		}

		if (fmtchunk && datachunk)
			break;

		// t@CTCY`FbNsȂ
	}

	fclose(fp);
	return true;
}

//	Wav t@Cǂݍ
bool Wave::Load(byte* pData)
{
	// f[^|C^擪AhXۑ
	byte* top = pData;


	char chunkId[5] = {};
	char tmp[5] = {};
	unsigned int chunkSize = 0;

	// RIFF`Nǂݍ
	memcpy(chunkId,pData,sizeof(char) * 4);
	pData += sizeof(char) * 4;

	memcpy(&chunkSize,pData,sizeof(unsigned int));
	pData += sizeof(unsigned int);

	memcpy(tmp,pData,sizeof(char) * 4);
	pData += sizeof(char) * 4;

	if (::strcmp(chunkId, "RIFF") || ::strcmp(tmp, "WAVE"))
	{
		return false;
	}

	// q`Nǂݍ
	bool fmtchunk	= false;
	bool datachunk	= false;
	while (true)
	{
		memcpy(chunkId,pData,sizeof(char) * 4);
		pData += sizeof(char) * 4;

		memcpy(&chunkSize,pData, sizeof(unsigned int));
		pData += sizeof(unsigned int);

		if (!::strcmp(chunkId, "fmt "))
		{
			if (chunkSize >= sizeof(WAVEFORMATEX))
			{
				memcpy(&m_Format, pData, sizeof(WAVEFORMATEX));
				pData += sizeof(WAVEFORMATEX);

				int diff = chunkSize - sizeof(WAVEFORMATEX);
				pData += diff;
			}
			else
			{
				::memset(&m_Format, 0, sizeof(WAVEFORMATEX));
				memcpy(&m_Format,pData,chunkSize);
				pData += chunkSize;
			}
			fmtchunk = true;
		}
		else if (!::strcmp(chunkId, "data"))
		{
			m_Data.resize(chunkSize);
			for(unsigned int i = 0;i < chunkSize;++i)
			{
				if(pData == NULL)
				{
					pData = top;
					return false;				
				}

				memcpy(&m_Data[i],pData,sizeof(byte));
				pData += sizeof(byte);
			}

			datachunk = true;
		}
		else
		{
			pData += chunkSize;
		}

		if (fmtchunk && datachunk)
			break;

		// t@CTCY`FbNsȂ
	}

	pData = top;
	return true;
}

//	Wave t@C\[Xǂݍ
bool Wave::Load(int ResourceID,const TCHAR* ResourceType,HINSTANCE hInstance)
{
	HRSRC hRsrc = FindResource(hInstance ,MAKEINTRESOURCE(ResourceID),ResourceType);
	// \[XȂ
	if(hRsrc == NULL)
		return false;

	HGLOBAL hGlobal = LoadResource(hInstance,hRsrc);
	// \[Xǂݍݎs
	if(hGlobal == NULL)
		return false;

	// \[XbN
	LPVOID pData = LockResource(hGlobal);
	// \[XTCY
	DWORD DataSize = SizeofResource(hInstance,hRsrc);

	return this->Load((byte*)pData);
}


// f[^擾
byte* Wave::GetData()
{
	return &m_Data[0];
}
// f[^TCY擾
DWORD Wave::GetDataSize()
{
	return (DWORD)m_Data.size();
}
// WavetH[}bg擾
WAVEFORMATEX* Wave::GetFormat()
{
	return &m_Format;
}





